/* Document.c generated by valac 0.56.16, the Vala compiler
 * generated from Document.vala, do not modify */

/* Document.vala
 *
 * Copyright 2023-2024 Diego Iván <diegoivan.mae@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <poppler.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <exempi/xmp.h>
#include <exempi/xmpconsts.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>

#define PAPER_CLIP_DOCUMENT_PDF_NS "http://ns.adobe.com/pdf/1.3/"
#define PAPER_CLIP_DOCUMENT_XMP_NS "http://ns.adobe.com/xap/1.0/"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define PAPER_CLIP_TYPE_DOCUMENT (paper_clip_document_get_type ())
#define PAPER_CLIP_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PAPER_CLIP_TYPE_DOCUMENT, PaperClipDocument))
#define PAPER_CLIP_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PAPER_CLIP_TYPE_DOCUMENT, PaperClipDocumentClass))
#define PAPER_CLIP_IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PAPER_CLIP_TYPE_DOCUMENT))
#define PAPER_CLIP_IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PAPER_CLIP_TYPE_DOCUMENT))
#define PAPER_CLIP_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PAPER_CLIP_TYPE_DOCUMENT, PaperClipDocumentClass))

typedef struct _PaperClipDocument PaperClipDocument;
typedef struct _PaperClipDocumentClass PaperClipDocumentClass;
typedef struct _PaperClipDocumentPrivate PaperClipDocumentPrivate;
enum  {
	PAPER_CLIP_DOCUMENT_0_PROPERTY,
	PAPER_CLIP_DOCUMENT_ORIGINAL_FILE_PROPERTY,
	PAPER_CLIP_DOCUMENT_CACHED_FILE_PROPERTY,
	PAPER_CLIP_DOCUMENT_HAS_XMP_PROPERTY,
	PAPER_CLIP_DOCUMENT_AUTHOR_PROPERTY,
	PAPER_CLIP_DOCUMENT_CREATOR_PROPERTY,
	PAPER_CLIP_DOCUMENT_SUBJECT_PROPERTY,
	PAPER_CLIP_DOCUMENT_TITLE_PROPERTY,
	PAPER_CLIP_DOCUMENT_PRODUCER_PROPERTY,
	PAPER_CLIP_DOCUMENT_CREATION_DATE_PROPERTY,
	PAPER_CLIP_DOCUMENT_MODIFICATION_DATE_PROPERTY,
	PAPER_CLIP_DOCUMENT_KEYWORDS_PROPERTY,
	PAPER_CLIP_DOCUMENT_FORMAT_PROPERTY,
	PAPER_CLIP_DOCUMENT_LAYOUT_PROPERTY,
	PAPER_CLIP_DOCUMENT_PRINT_DUPLEX_PROPERTY,
	PAPER_CLIP_DOCUMENT_SUBTYPE_PROPERTY,
	PAPER_CLIP_DOCUMENT_VIEWER_PREFERENCES_PROPERTY,
	PAPER_CLIP_DOCUMENT_PERMISSIONS_PROPERTY,
	PAPER_CLIP_DOCUMENT_NUM_PROPERTIES
};
static GParamSpec* paper_clip_document_properties[PAPER_CLIP_DOCUMENT_NUM_PROPERTIES];

#define PAPER_CLIP_TYPE_STRING_OBJECT (paper_clip_string_object_get_type ())
#define PAPER_CLIP_STRING_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PAPER_CLIP_TYPE_STRING_OBJECT, PaperClipStringObject))
#define PAPER_CLIP_STRING_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PAPER_CLIP_TYPE_STRING_OBJECT, PaperClipStringObjectClass))
#define PAPER_CLIP_IS_STRING_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PAPER_CLIP_TYPE_STRING_OBJECT))
#define PAPER_CLIP_IS_STRING_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PAPER_CLIP_TYPE_STRING_OBJECT))
#define PAPER_CLIP_STRING_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PAPER_CLIP_TYPE_STRING_OBJECT, PaperClipStringObjectClass))

typedef struct _PaperClipStringObject PaperClipStringObject;
typedef struct _PaperClipStringObjectClass PaperClipStringObjectClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef gpointer (*ThreadManagerThreadFunc) (gpointer user_data, GError** error);
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _PaperClipDocumentNewData PaperClipDocumentNewData;
#define _xmp_files_free0(var) ((var == NULL) ? NULL : (var = (xmp_files_free (var), NULL)))
#define _xmp_free0(var) ((var == NULL) ? NULL : (var = (xmp_free (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _PaperClipDocumentSaveData PaperClipDocumentSaveData;

#define PAPER_CLIP_TYPE_XMP_ERROR (paper_clip_xmp_error_get_type ())
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _PaperClipDocumentLoadDocumentData PaperClipDocumentLoadDocumentData;
typedef struct _PaperClipDocumentCreateCopyFromOriginalData PaperClipDocumentCreateCopyFromOriginalData;
enum  {
	PAPER_CLIP_DOCUMENT_KEYWORD_CHANGED_SIGNAL,
	PAPER_CLIP_DOCUMENT_NUM_SIGNALS
};
static guint paper_clip_document_signals[PAPER_CLIP_DOCUMENT_NUM_SIGNALS] = {0};
typedef struct _PaperClipStringObjectPrivate PaperClipStringObjectPrivate;
enum  {
	PAPER_CLIP_STRING_OBJECT_0_PROPERTY,
	PAPER_CLIP_STRING_OBJECT_STR_PROPERTY,
	PAPER_CLIP_STRING_OBJECT_NUM_PROPERTIES
};
static GParamSpec* paper_clip_string_object_properties[PAPER_CLIP_STRING_OBJECT_NUM_PROPERTIES];

struct _PaperClipDocument {
	GObject parent_instance;
	PaperClipDocumentPrivate * priv;
};

struct _PaperClipDocumentClass {
	GObjectClass parent_class;
};

struct _PaperClipDocumentPrivate {
	GListStore* keyword_list;
	PopplerDocument* _document;
	GFile* _original_file;
	GFile* _cached_file;
	gboolean _has_xmp;
	GRecMutex __lock_document;
};

struct _PaperClipDocumentNewData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GType object_type;
	PaperClipDocument* self;
	GFile* original_file;
	gchar* password;
	gboolean _tmp0_;
	gpointer _tmp1_;
	GError* e;
	GError* _tmp2_;
	const gchar* _tmp3_;
	GError* _inner_error0_;
};

struct _Block1Data {
	int _ref_count_;
	PaperClipDocument* self;
	gchar* uri;
	gpointer _async_data_;
};

struct _PaperClipDocumentSaveData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PaperClipDocument* self;
	gchar* uri;
	Block1Data* _data1_;
	GError* e;
	GError* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_;
};

typedef enum  {
	PAPER_CLIP_XMP_ERROR_NO_XMP,
	PAPER_CLIP_XMP_ERROR_FAILED_TO_OPEN
} PaperClipXmpError;
#define PAPER_CLIP_XMP_ERROR paper_clip_xmp_error_quark ()

struct _PaperClipDocumentLoadDocumentData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PaperClipDocument* self;
	gchar* password;
	GFile* _tmp0_;
	GFile* _tmp1_;
	PopplerDocument* _tmp2_;
	GFile* _tmp3_;
	PopplerDocument* _tmp4_;
	GError* _inner_error0_;
};

struct _PaperClipDocumentCreateCopyFromOriginalData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PaperClipDocument* self;
	GFile* result;
	const gchar* tmp_dir;
	const gchar* _tmp0_;
	gchar* destination_path;
	gchar* _tmp1_;
	gint res;
	gchar* destination_file;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* copy_file;
	GFile* _tmp9_;
	GFileCopyFlags flags;
	gboolean success;
	GFile* _tmp10_;
	GError* _inner_error0_;
};

struct _PaperClipStringObject {
	GObject parent_instance;
	PaperClipStringObjectPrivate * priv;
};

struct _PaperClipStringObjectClass {
	GObjectClass parent_class;
};

struct _PaperClipStringObjectPrivate {
	gchar* _str;
};

static gint PaperClipDocument_private_offset;
static gpointer paper_clip_document_parent_class = NULL;
static gint PaperClipStringObject_private_offset;
static gpointer paper_clip_string_object_parent_class = NULL;

VALA_EXTERN GType paper_clip_document_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PaperClipDocument, g_object_unref)
VALA_EXTERN GType paper_clip_string_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PaperClipStringObject, g_object_unref)
static void paper_clip_document_construct_data_free (gpointer _data);
VALA_EXTERN void paper_clip_document_new (GFile* original_file,
                              const gchar* password,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
VALA_EXTERN PaperClipDocument* paper_clip_document_new_finish (GAsyncResult* _res_,
                                                   GError** error);
VALA_EXTERN void paper_clip_document_construct (GType object_type,
                                    GFile* original_file,
                                    const gchar* password,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
VALA_EXTERN PaperClipDocument* paper_clip_document_construct_finish (GAsyncResult* _res_,
                                                         GError** error);
static gboolean paper_clip_document_construct_co (PaperClipDocumentNewData* _data_);
static void paper_clip_document_load_document (PaperClipDocument* self,
                                        const gchar* password,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static void paper_clip_document_load_document_finish (PaperClipDocument* self,
                                               GAsyncResult* _res_,
                                               GError** error);
static void paper_clip_document_new_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_);
VALA_EXTERN void thread_manager_run_in_thread (GType g_type,
                                   GBoxedCopyFunc g_dup_func,
                                   GDestroyNotify g_destroy_func,
                                   ThreadManagerThreadFunc thread_func,
                                   gpointer thread_func_target,
                                   GDestroyNotify thread_func_target_destroy_notify,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN gpointer thread_manager_run_in_thread_finish (GAsyncResult* _res_,
                                              GError** error);
static gboolean paper_clip_document_load_xmp (PaperClipDocument* self,
                                       GError** error);
static gpointer _paper_clip_document_load_xmp_thread_manager_thread_func (gpointer self,
                                                                   GError** error);
static void paper_clip_document_set_has_xmp (PaperClipDocument* self,
                                      gboolean value);
VALA_EXTERN GFile* paper_clip_document_get_original_file (PaperClipDocument* self);
static gboolean* _bool_dup (gboolean* self);
static void paper_clip_document_save_data_free (gpointer _data);
VALA_EXTERN void paper_clip_document_save (PaperClipDocument* self,
                               const gchar* uri,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN void paper_clip_document_save_finish (PaperClipDocument* self,
                                      GAsyncResult* _res_);
static gboolean paper_clip_document_save_co (PaperClipDocumentSaveData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void ___lambda6_ (Block1Data* _data1_,
                  GError** error);
static void paper_clip_document_save_thread (PaperClipDocument* self,
                                      const gchar* uri,
                                      GError** error);
static gpointer ____lambda6__thread_manager_thread_func (gpointer self,
                                                  GError** error);
static void paper_clip_document_save_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
static PopplerDocument* paper_clip_document_get_document (PaperClipDocument* self);
static gchar* paper_clip_document_serialize_keywords (PaperClipDocument* self);
VALA_EXTERN gboolean paper_clip_document_get_has_xmp (PaperClipDocument* self);
VALA_EXTERN GQuark paper_clip_xmp_error_quark (void);
VALA_EXTERN GType paper_clip_xmp_error_get_type (void) G_GNUC_CONST ;
static void paper_clip_document_save_xmp (PaperClipDocument* self,
                                   const gchar* uri,
                                   GError** error);
VALA_EXTERN gchar* paper_clip_document_get_producer (PaperClipDocument* self);
VALA_EXTERN gchar* paper_clip_document_get_creator (PaperClipDocument* self);
VALA_EXTERN gchar* paper_clip_document_get_title (PaperClipDocument* self);
VALA_EXTERN GDateTime* paper_clip_document_get_creation_date (PaperClipDocument* self);
VALA_EXTERN GDateTime* paper_clip_document_get_modification_date (PaperClipDocument* self);
VALA_EXTERN void paper_clip_document_add_keyword (PaperClipDocument* self,
                                      const gchar* keyword);
VALA_EXTERN PaperClipStringObject* paper_clip_string_object_new (const gchar* str);
VALA_EXTERN PaperClipStringObject* paper_clip_string_object_construct (GType object_type,
                                                           const gchar* str);
static void __lambda4_ (PaperClipDocument* self);
static void ___lambda4__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
VALA_EXTERN gboolean paper_clip_document_remove_keyword (PaperClipDocument* self,
                                             const gchar* keyword);
VALA_EXTERN const gchar* paper_clip_string_object_get_str (PaperClipStringObject* self);
VALA_EXTERN PopplerPage* paper_clip_document_get_page_for_index (PaperClipDocument* self,
                                                     gint index);
static void paper_clip_document_deserialize_keywords (PaperClipDocument* self);
VALA_EXTERN GListModel* paper_clip_document_get_keywords (PaperClipDocument* self);
static gchar* paper_clip_document_layout_to_string (PaperClipDocument* self);
static gchar** paper_clip_document_viewer_preferences_to_string_array (PaperClipDocument* self,
                                                                gint* result_length1);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add7 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add9 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static gchar** paper_clip_document_permissions_to_string_array (PaperClipDocument* self,
                                                         gint* result_length1);
static void _vala_array_add10 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add11 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add12 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add14 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add15 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add16 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add17 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gchar* paper_clip_document_print_duplex_to_string (PaperClipDocument* self);
static gchar* paper_clip_document_subtype_to_string (PaperClipDocument* self);
static void paper_clip_document_load_document_data_free (gpointer _data);
static gboolean paper_clip_document_load_document_co (PaperClipDocumentLoadDocumentData* _data_);
static void paper_clip_document_create_copy_from_original (PaperClipDocument* self,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
static GFile* paper_clip_document_create_copy_from_original_finish (PaperClipDocument* self,
                                                             GAsyncResult* _res_,
                                                             GError** error);
static void paper_clip_document_load_document_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void paper_clip_document_set_cached_file (PaperClipDocument* self,
                                          GFile* value);
VALA_EXTERN GFile* paper_clip_document_get_cached_file (PaperClipDocument* self);
static void paper_clip_document_set_document (PaperClipDocument* self,
                                       PopplerDocument* value);
static void paper_clip_document_create_copy_from_original_data_free (gpointer _data);
static gboolean paper_clip_document_create_copy_from_original_co (PaperClipDocumentCreateCopyFromOriginalData* _data_);
static void paper_clip_document_create_copy_from_original_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void paper_clip_document_set_original_file (PaperClipDocument* self,
                                            GFile* value);
VALA_EXTERN gchar* paper_clip_document_get_author (PaperClipDocument* self);
VALA_EXTERN void paper_clip_document_set_author (PaperClipDocument* self,
                                     const gchar* value);
VALA_EXTERN void paper_clip_document_set_creator (PaperClipDocument* self,
                                      const gchar* value);
VALA_EXTERN gchar* paper_clip_document_get_subject (PaperClipDocument* self);
VALA_EXTERN void paper_clip_document_set_subject (PaperClipDocument* self,
                                      const gchar* value);
VALA_EXTERN void paper_clip_document_set_title (PaperClipDocument* self,
                                    const gchar* value);
VALA_EXTERN void paper_clip_document_set_producer (PaperClipDocument* self,
                                       const gchar* value);
VALA_EXTERN void paper_clip_document_set_creation_date (PaperClipDocument* self,
                                            GDateTime* value);
VALA_EXTERN void paper_clip_document_set_modification_date (PaperClipDocument* self,
                                                GDateTime* value);
VALA_EXTERN gchar* paper_clip_document_get_format (PaperClipDocument* self);
VALA_EXTERN gchar* paper_clip_document_get_layout (PaperClipDocument* self);
VALA_EXTERN gchar* paper_clip_document_get_print_duplex (PaperClipDocument* self);
VALA_EXTERN gchar* paper_clip_document_get_subtype (PaperClipDocument* self);
VALA_EXTERN gchar** paper_clip_document_get_viewer_preferences (PaperClipDocument* self,
                                                    gint* result_length1);
VALA_EXTERN gchar** paper_clip_document_get_permissions (PaperClipDocument* self,
                                             gint* result_length1);
static void paper_clip_document_finalize (GObject * obj);
static GType paper_clip_document_get_type_once (void);
static void _vala_paper_clip_document_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_paper_clip_document_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
VALA_EXTERN void paper_clip_string_object_set_str (PaperClipStringObject* self,
                                       const gchar* value);
static void paper_clip_string_object_finalize (GObject * obj);
static GType paper_clip_string_object_get_type_once (void);
static void _vala_paper_clip_string_object_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_paper_clip_string_object_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
paper_clip_document_get_instance_private (PaperClipDocument* self)
{
	return G_STRUCT_MEMBER_P (self, PaperClipDocument_private_offset);
}

static void
paper_clip_document_construct_data_free (gpointer _data)
{
	PaperClipDocumentNewData* _data_;
	_data_ = _data;
#line 158 "../src/Document.vala"
	_g_object_unref0 (_data_->original_file);
#line 158 "../src/Document.vala"
	_g_free0 (_data_->password);
#line 158 "../src/Document.vala"
	_g_object_unref0 (_data_->self);
#line 158 "../src/Document.vala"
	g_slice_free (PaperClipDocumentNewData, _data_);
#line 511 "Document.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 158 "../src/Document.vala"
	return self ? g_object_ref (self) : NULL;
#line 519 "Document.c"
}

void
paper_clip_document_construct (GType object_type,
                               GFile* original_file,
                               const gchar* password,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	PaperClipDocumentNewData* _data_;
	GFile* _tmp0_;
	gchar* _tmp1_;
#line 158 "../src/Document.vala"
	g_return_if_fail (original_file != NULL);
#line 158 "../src/Document.vala"
	_data_ = g_slice_new0 (PaperClipDocumentNewData);
#line 158 "../src/Document.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 158 "../src/Document.vala"
	g_task_set_task_data (_data_->_async_result, _data_, paper_clip_document_construct_data_free);
#line 158 "../src/Document.vala"
	_data_->object_type = object_type;
#line 158 "../src/Document.vala"
	_tmp0_ = _g_object_ref0 (original_file);
#line 158 "../src/Document.vala"
	_g_object_unref0 (_data_->original_file);
#line 158 "../src/Document.vala"
	_data_->original_file = _tmp0_;
#line 158 "../src/Document.vala"
	_tmp1_ = g_strdup (password);
#line 158 "../src/Document.vala"
	_g_free0 (_data_->password);
#line 158 "../src/Document.vala"
	_data_->password = _tmp1_;
#line 158 "../src/Document.vala"
	paper_clip_document_construct_co (_data_);
#line 556 "Document.c"
}

PaperClipDocument*
paper_clip_document_construct_finish (GAsyncResult* _res_,
                                      GError** error)
{
	PaperClipDocument* result;
	PaperClipDocumentNewData* _data_;
#line 158 "../src/Document.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 158 "../src/Document.vala"
	if (NULL == _data_) {
#line 158 "../src/Document.vala"
		return NULL;
#line 571 "Document.c"
	}
#line 158 "../src/Document.vala"
	result = _data_->self;
#line 158 "../src/Document.vala"
	_data_->self = NULL;
#line 158 "../src/Document.vala"
	return result;
#line 579 "Document.c"
}

static void
paper_clip_document_new_ready (GObject* source_object,
                               GAsyncResult* _res_,
                               gpointer _user_data_)
{
	PaperClipDocumentNewData* _data_;
#line 160 "../src/Document.vala"
	_data_ = _user_data_;
#line 160 "../src/Document.vala"
	_data_->_source_object_ = source_object;
#line 160 "../src/Document.vala"
	_data_->_res_ = _res_;
#line 160 "../src/Document.vala"
	paper_clip_document_construct_co (_data_);
#line 596 "Document.c"
}

static gpointer
_paper_clip_document_load_xmp_thread_manager_thread_func (gpointer self,
                                                          GError** error)
{
	gpointer result;
	result = (gpointer) ((gintptr) paper_clip_document_load_xmp ((PaperClipDocument*) self, error));
#line 163 "../src/Document.vala"
	return result;
#line 607 "Document.c"
}

static gboolean
paper_clip_document_construct_co (PaperClipDocumentNewData* _data_)
{
#line 158 "../src/Document.vala"
	switch (_data_->_state_) {
#line 158 "../src/Document.vala"
		case 0:
#line 617 "Document.c"
		goto _state_0;
#line 158 "../src/Document.vala"
		case 1:
#line 621 "Document.c"
		goto _state_1;
#line 158 "../src/Document.vala"
		case 2:
#line 625 "Document.c"
		goto _state_2;
		default:
#line 158 "../src/Document.vala"
		g_assert_not_reached ();
#line 630 "Document.c"
	}
	_state_0:
#line 159 "../src/Document.vala"
	_data_->self = (PaperClipDocument*) g_object_new (_data_->object_type, "original-file", _data_->original_file, NULL);
#line 160 "../src/Document.vala"
	_data_->_state_ = 1;
#line 160 "../src/Document.vala"
	paper_clip_document_load_document (_data_->self, _data_->password, paper_clip_document_new_ready, _data_);
#line 160 "../src/Document.vala"
	return FALSE;
#line 641 "Document.c"
	_state_1:
#line 160 "../src/Document.vala"
	paper_clip_document_load_document_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 160 "../src/Document.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 160 "../src/Document.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 160 "../src/Document.vala"
		g_object_unref (_data_->_async_result);
#line 160 "../src/Document.vala"
		return FALSE;
#line 653 "Document.c"
	}
	{
#line 163 "../src/Document.vala"
		_data_->_state_ = 2;
#line 163 "../src/Document.vala"
		thread_manager_run_in_thread (G_TYPE_BOOLEAN, NULL, NULL, _paper_clip_document_load_xmp_thread_manager_thread_func, g_object_ref (_data_->self), g_object_unref, paper_clip_document_new_ready, _data_);
#line 163 "../src/Document.vala"
		return FALSE;
#line 662 "Document.c"
		_state_2:
#line 163 "../src/Document.vala"
		_data_->_tmp1_ = thread_manager_run_in_thread_finish (_data_->_res_, &_data_->_inner_error0_);
#line 163 "../src/Document.vala"
		_data_->_tmp0_ = (gboolean) ((gintptr) _data_->_tmp1_);
#line 163 "../src/Document.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 670 "Document.c"
			goto __catch0_g_error;
		}
#line 163 "../src/Document.vala"
		paper_clip_document_set_has_xmp (_data_->self, _data_->_tmp0_);
#line 675 "Document.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 162 "../src/Document.vala"
		_data_->e = _data_->_inner_error0_;
#line 162 "../src/Document.vala"
		_data_->_inner_error0_ = NULL;
#line 165 "../src/Document.vala"
		_data_->_tmp2_ = _data_->e;
#line 165 "../src/Document.vala"
		_data_->_tmp3_ = _data_->_tmp2_->message;
#line 165 "../src/Document.vala"
		g_critical ("Document.vala:165: %s", _data_->_tmp3_);
#line 162 "../src/Document.vala"
		_g_error_free0 (_data_->e);
#line 692 "Document.c"
	}
	__finally0:
#line 162 "../src/Document.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 162 "../src/Document.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 162 "../src/Document.vala"
		g_object_unref (_data_->_async_result);
#line 162 "../src/Document.vala"
		return FALSE;
#line 703 "Document.c"
	}
#line 158 "../src/Document.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 158 "../src/Document.vala"
	if (_data_->_state_ != 0) {
#line 158 "../src/Document.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 158 "../src/Document.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 713 "Document.c"
		}
	}
#line 158 "../src/Document.vala"
	g_object_unref (_data_->_async_result);
#line 158 "../src/Document.vala"
	return FALSE;
#line 720 "Document.c"
}

void
paper_clip_document_new (GFile* original_file,
                         const gchar* password,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
#line 158 "../src/Document.vala"
	paper_clip_document_construct (PAPER_CLIP_TYPE_DOCUMENT, original_file, password, _callback_, _user_data_);
#line 731 "Document.c"
}

PaperClipDocument*
paper_clip_document_new_finish (GAsyncResult* _res_,
                                GError** error)
{
#line 158 "../src/Document.vala"
	return paper_clip_document_construct_finish (_res_, error);
#line 740 "Document.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 184 "../src/Document.vala"
	dup = g_new0 (gboolean, 1);
#line 184 "../src/Document.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 184 "../src/Document.vala"
	return dup;
#line 753 "Document.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 184 "../src/Document.vala"
	return self ? _bool_dup (self) : NULL;
#line 761 "Document.c"
}

static gboolean
paper_clip_document_load_xmp (PaperClipDocument* self,
                              GError** error)
{
	gboolean success = FALSE;
	struct _XmpFile* xmp_file = NULL;
	struct _XmpFile* _tmp0_;
	gboolean opened_file = FALSE;
	struct _XmpFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	struct _Xmp* xmp_meta = NULL;
	struct _Xmp* _tmp6_;
	struct _XmpFile* _tmp7_;
	struct _Xmp* _tmp8_;
	struct _XmpFile* _tmp9_ = NULL;
	struct _XmpFile* _tmp10_;
	gboolean* _tmp11_ = NULL;
	gboolean result;
#line 170 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/Document.vala"
	success = FALSE;
#line 172 "../src/Document.vala"
	_tmp0_ = xmp_files_new ();
#line 172 "../src/Document.vala"
	xmp_file = _tmp0_;
#line 173 "../src/Document.vala"
	_tmp1_ = xmp_file;
#line 173 "../src/Document.vala"
	_tmp2_ = self->priv->_original_file;
#line 173 "../src/Document.vala"
	_tmp3_ = g_file_get_path (_tmp2_);
#line 173 "../src/Document.vala"
	_tmp4_ = _tmp3_;
#line 173 "../src/Document.vala"
	_tmp5_ = xmp_files_open (_tmp1_, _tmp4_, (XMP_OPEN_READ | XMP_OPEN_INBACKGROUND) | XMP_OPEN_ONLYXMP);
#line 173 "../src/Document.vala"
	_g_free0 (_tmp4_);
#line 173 "../src/Document.vala"
	opened_file = _tmp5_;
#line 175 "../src/Document.vala"
	if (!opened_file) {
#line 176 "../src/Document.vala"
		g_debug ("Document.vala:176: Failed to open file with XMP");
#line 177 "../src/Document.vala"
		result = FALSE;
#line 177 "../src/Document.vala"
		_xmp_files_free0 (xmp_file);
#line 177 "../src/Document.vala"
		return result;
#line 817 "Document.c"
	}
#line 179 "../src/Document.vala"
	_tmp6_ = xmp_new_empty ();
#line 179 "../src/Document.vala"
	xmp_meta = _tmp6_;
#line 180 "../src/Document.vala"
	_tmp7_ = xmp_file;
#line 180 "../src/Document.vala"
	_tmp8_ = xmp_meta;
#line 180 "../src/Document.vala"
	success = xmp_files_get_xmp (_tmp7_, _tmp8_);
#line 181 "../src/Document.vala"
	if (!success) {
#line 182 "../src/Document.vala"
		g_debug ("Document.vala:182: File does not have XMP metadata");
#line 833 "Document.c"
	}
#line 184 "../src/Document.vala"
	_tmp10_ = xmp_file;
#line 184 "../src/Document.vala"
	_tmp9_ = _tmp10_;
#line 184 "../src/Document.vala"
	_tmp11_ = NULL;
#line 184 "../src/Document.vala"
	if (_tmp9_ != NULL) {
#line 843 "Document.c"
		gboolean _tmp12_;
		gboolean* _tmp13_;
#line 184 "../src/Document.vala"
		_tmp12_ = xmp_files_close (_tmp9_, XMP_CLOSE_NOOPTION);
#line 184 "../src/Document.vala"
		_tmp13_ = __bool_dup0 (&_tmp12_);
#line 184 "../src/Document.vala"
		_g_free0 (_tmp11_);
#line 184 "../src/Document.vala"
		_tmp11_ = _tmp13_;
#line 854 "Document.c"
	}
#line 185 "../src/Document.vala"
	result = success;
#line 185 "../src/Document.vala"
	_g_free0 (_tmp11_);
#line 185 "../src/Document.vala"
	_xmp_free0 (xmp_meta);
#line 185 "../src/Document.vala"
	_xmp_files_free0 (xmp_file);
#line 185 "../src/Document.vala"
	return result;
#line 866 "Document.c"
}

static void
paper_clip_document_save_data_free (gpointer _data)
{
	PaperClipDocumentSaveData* _data_;
	_data_ = _data;
#line 21 "../src/Document.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/Document.vala"
	g_slice_free (PaperClipDocumentSaveData, _data_);
#line 878 "Document.c"
}

void
paper_clip_document_save (PaperClipDocument* self,
                          const gchar* uri,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	PaperClipDocumentSaveData* _data_;
	PaperClipDocument* _tmp0_;
	gchar* _tmp1_;
#line 21 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Document.vala"
	g_return_if_fail (uri != NULL);
#line 21 "../src/Document.vala"
	_data_ = g_slice_new0 (PaperClipDocumentSaveData);
#line 21 "../src/Document.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/Document.vala"
	g_task_set_task_data (_data_->_async_result, _data_, paper_clip_document_save_data_free);
#line 21 "../src/Document.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/Document.vala"
	_data_->self = _tmp0_;
#line 21 "../src/Document.vala"
	_tmp1_ = g_strdup (uri);
#line 21 "../src/Document.vala"
	_g_free0 (_data_->uri);
#line 21 "../src/Document.vala"
	_data_->uri = _tmp1_;
#line 21 "../src/Document.vala"
	paper_clip_document_save_co (_data_);
#line 912 "Document.c"
}

void
paper_clip_document_save_finish (PaperClipDocument* self,
                                 GAsyncResult* _res_)
{
	PaperClipDocumentSaveData* _data_;
#line 21 "../src/Document.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 922 "Document.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 188 "../src/Document.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 188 "../src/Document.vala"
	return _data1_;
#line 932 "Document.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 188 "../src/Document.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 942 "Document.c"
		PaperClipDocument* self;
#line 188 "../src/Document.vala"
		self = _data1_->self;
#line 188 "../src/Document.vala"
		_g_free0 (_data1_->uri);
#line 188 "../src/Document.vala"
		_g_object_unref0 (self);
#line 188 "../src/Document.vala"
		g_slice_free (Block1Data, _data1_);
#line 952 "Document.c"
	}
}

static void
___lambda6_ (Block1Data* _data1_,
             GError** error)
{
	PaperClipDocument* self;
	GError* _inner_error0_ = NULL;
#line 190 "../src/Document.vala"
	self = _data1_->self;
#line 190 "../src/Document.vala"
	paper_clip_document_save_thread (self, _data1_->uri, &_inner_error0_);
#line 190 "../src/Document.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../src/Document.vala"
		g_propagate_error (error, _inner_error0_);
#line 190 "../src/Document.vala"
		return;
#line 972 "Document.c"
	}
}

static gpointer
____lambda6__thread_manager_thread_func (gpointer self,
                                         GError** error)
{
	gpointer result;
#line 190 "../src/Document.vala"
	___lambda6_ (self, error);
#line 983 "Document.c"
	result = NULL;
#line 190 "../src/Document.vala"
	return result;
#line 987 "Document.c"
}

static void
paper_clip_document_save_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	PaperClipDocumentSaveData* _data_;
#line 190 "../src/Document.vala"
	_data_ = _user_data_;
#line 190 "../src/Document.vala"
	_data_->_source_object_ = source_object;
#line 190 "../src/Document.vala"
	_data_->_res_ = _res_;
#line 190 "../src/Document.vala"
	paper_clip_document_save_co (_data_);
#line 1004 "Document.c"
}

static gboolean
paper_clip_document_save_co (PaperClipDocumentSaveData* _data_)
{
#line 188 "../src/Document.vala"
	switch (_data_->_state_) {
#line 188 "../src/Document.vala"
		case 0:
#line 1014 "Document.c"
		goto _state_0;
#line 188 "../src/Document.vala"
		case 1:
#line 1018 "Document.c"
		goto _state_1;
		default:
#line 188 "../src/Document.vala"
		g_assert_not_reached ();
#line 1023 "Document.c"
	}
	_state_0:
#line 188 "../src/Document.vala"
	_data_->_data1_ = g_slice_new0 (Block1Data);
#line 188 "../src/Document.vala"
	_data_->_data1_->_ref_count_ = 1;
#line 188 "../src/Document.vala"
	_data_->_data1_->self = g_object_ref (_data_->self);
#line 188 "../src/Document.vala"
	_g_free0 (_data_->_data1_->uri);
#line 188 "../src/Document.vala"
	_data_->_data1_->uri = _data_->uri;
#line 188 "../src/Document.vala"
	_data_->_data1_->_async_data_ = _data_;
#line 1038 "Document.c"
	{
#line 190 "../src/Document.vala"
		_data_->_state_ = 1;
#line 190 "../src/Document.vala"
		thread_manager_run_in_thread (G_TYPE_NONE, NULL, NULL, ____lambda6__thread_manager_thread_func, block1_data_ref (_data_->_data1_), block1_data_unref, paper_clip_document_save_ready, _data_);
#line 190 "../src/Document.vala"
		return FALSE;
#line 1046 "Document.c"
		_state_1:
#line 190 "../src/Document.vala"
		thread_manager_run_in_thread_finish (_data_->_res_, &_data_->_inner_error0_);
#line 190 "../src/Document.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1052 "Document.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 189 "../src/Document.vala"
		_data_->e = _data_->_inner_error0_;
#line 189 "../src/Document.vala"
		_data_->_inner_error0_ = NULL;
#line 192 "../src/Document.vala"
		_data_->_tmp0_ = _data_->e;
#line 192 "../src/Document.vala"
		_data_->_tmp1_ = _data_->_tmp0_->message;
#line 192 "../src/Document.vala"
		g_critical ("Document.vala:192: %s", _data_->_tmp1_);
#line 189 "../src/Document.vala"
		_g_error_free0 (_data_->e);
#line 1071 "Document.c"
	}
	__finally0:
#line 189 "../src/Document.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 189 "../src/Document.vala"
		block1_data_unref (_data_->_data1_);
#line 189 "../src/Document.vala"
		_data_->_data1_ = NULL;
#line 189 "../src/Document.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 189 "../src/Document.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 189 "../src/Document.vala"
		g_object_unref (_data_->_async_result);
#line 189 "../src/Document.vala"
		return FALSE;
#line 1088 "Document.c"
	}
#line 188 "../src/Document.vala"
	block1_data_unref (_data_->_data1_);
#line 188 "../src/Document.vala"
	_data_->_data1_ = NULL;
#line 188 "../src/Document.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 188 "../src/Document.vala"
	if (_data_->_state_ != 0) {
#line 188 "../src/Document.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 188 "../src/Document.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1102 "Document.c"
		}
	}
#line 188 "../src/Document.vala"
	g_object_unref (_data_->_async_result);
#line 188 "../src/Document.vala"
	return FALSE;
#line 1109 "Document.c"
}

static void
paper_clip_document_save_thread (PaperClipDocument* self,
                                 const gchar* uri,
                                 GError** error)
{
	gboolean _tmp11_;
	GError* _inner_error0_ = NULL;
#line 196 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 196 "../src/Document.vala"
	g_return_if_fail (uri != NULL);
#line 1123 "Document.c"
	{
		PopplerDocument* _tmp0_;
		PopplerDocument* _tmp1_;
#line 197 "../src/Document.vala"
		_tmp0_ = paper_clip_document_get_document (self);
#line 197 "../src/Document.vala"
		_tmp1_ = _tmp0_;
#line 197 "../src/Document.vala"
		g_rec_mutex_lock (&self->priv->__lock_document);
#line 1133 "Document.c"
		{
			PopplerDocument* _tmp2_;
			PopplerDocument* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			PopplerDocument* _tmp6_;
			PopplerDocument* _tmp7_;
#line 198 "../src/Document.vala"
			_tmp2_ = paper_clip_document_get_document (self);
#line 198 "../src/Document.vala"
			_tmp3_ = _tmp2_;
#line 198 "../src/Document.vala"
			_tmp4_ = paper_clip_document_serialize_keywords (self);
#line 198 "../src/Document.vala"
			_tmp5_ = _tmp4_;
#line 198 "../src/Document.vala"
			poppler_document_set_keywords (_tmp3_, _tmp5_);
#line 198 "../src/Document.vala"
			_g_free0 (_tmp5_);
#line 199 "../src/Document.vala"
			_tmp6_ = paper_clip_document_get_document (self);
#line 199 "../src/Document.vala"
			_tmp7_ = _tmp6_;
#line 199 "../src/Document.vala"
			poppler_document_save (_tmp7_, uri, &_inner_error0_);
#line 199 "../src/Document.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1161 "Document.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _lock_error_ = NULL;
			GError* _tmp8_;
#line 197 "../src/Document.vala"
			_lock_error_ = _inner_error0_;
#line 197 "../src/Document.vala"
			_inner_error0_ = NULL;
#line 197 "../src/Document.vala"
			_tmp8_ = _lock_error_;
#line 197 "../src/Document.vala"
			_lock_error_ = NULL;
#line 197 "../src/Document.vala"
			_inner_error0_ = _tmp8_;
#line 197 "../src/Document.vala"
			_g_error_free0 (_lock_error_);
#line 1182 "Document.c"
			goto __finally0;
		}
		__finally0:
		{
			GError* _inner_error1_ = NULL;
			PopplerDocument* _tmp9_;
			PopplerDocument* _tmp10_;
#line 197 "../src/Document.vala"
			_tmp9_ = paper_clip_document_get_document (self);
#line 197 "../src/Document.vala"
			_tmp10_ = _tmp9_;
#line 197 "../src/Document.vala"
			g_rec_mutex_unlock (&self->priv->__lock_document);
#line 1196 "Document.c"
		}
#line 197 "../src/Document.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 197 "../src/Document.vala"
			return;
#line 1204 "Document.c"
		}
	}
#line 201 "../src/Document.vala"
	_tmp11_ = self->priv->_has_xmp;
#line 201 "../src/Document.vala"
	if (_tmp11_) {
#line 202 "../src/Document.vala"
		paper_clip_document_save_xmp (self, uri, &_inner_error0_);
#line 202 "../src/Document.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "../src/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 202 "../src/Document.vala"
			return;
#line 1219 "Document.c"
		}
	}
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1589 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1590 "glib-2.0.vapi"
	result = self;
#line 1590 "glib-2.0.vapi"
	return result;
#line 1234 "Document.c"
}

static gboolean
__vala_xmp_set_property_date (struct _Xmp* self,
                              const gchar* schema,
                              const gchar* name,
                              GDateTime* value,
                              guint32 option_bits)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 375 "exempi-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 375 "exempi-2.0.vapi"
	g_return_val_if_fail (schema != NULL, FALSE);
#line 375 "exempi-2.0.vapi"
	g_return_val_if_fail (name != NULL, FALSE);
#line 375 "exempi-2.0.vapi"
	g_return_val_if_fail (value != NULL, FALSE);
#line 376 "exempi-2.0.vapi"
	_tmp0_ = g_date_time_format_iso8601 (value);
#line 376 "exempi-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 376 "exempi-2.0.vapi"
	_tmp2_ = xmp_set_property (self, schema, name, _tmp1_, option_bits);
#line 376 "exempi-2.0.vapi"
	_g_free0 (_tmp1_);
#line 376 "exempi-2.0.vapi"
	result = _tmp2_;
#line 376 "exempi-2.0.vapi"
	return result;
#line 1268 "Document.c"
}

static void
paper_clip_document_save_xmp (PaperClipDocument* self,
                              const gchar* uri,
                              GError** error)
{
	struct _XmpFile* xmp_file = NULL;
	struct _XmpFile* _tmp0_;
	XmpOpenFileOptions options = 0U;
	GFile* file = NULL;
	GFile* _tmp1_;
	gchar* path = NULL;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gboolean success = FALSE;
	struct _XmpFile* _tmp4_;
	const gchar* _tmp5_;
	struct _Xmp* xmp_meta = NULL;
	struct _Xmp* _tmp14_;
	gboolean has_meta = FALSE;
	struct _XmpFile* _tmp15_;
	struct _Xmp* _tmp16_;
	struct _Xmp* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	struct _Xmp* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	struct _Xmp* _tmp31_;
	PopplerDocument* _tmp32_;
	PopplerDocument* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	struct _Xmp* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	GDateTime* _tmp41_;
	GDateTime* _tmp42_;
	GDateTime* _tmp43_;
	gboolean _tmp44_;
	GDateTime* _tmp50_;
	GDateTime* _tmp51_;
	GDateTime* _tmp52_;
	gboolean _tmp53_;
	GDateTime* metadata_date = NULL;
	GDateTime* _tmp59_;
	struct _Xmp* _tmp60_;
	GDateTime* _tmp61_;
	struct _XmpFile* _tmp62_;
	struct _Xmp* _tmp63_;
	struct _XmpFile* _tmp66_;
	GError* _inner_error0_ = NULL;
#line 206 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/Document.vala"
	g_return_if_fail (uri != NULL);
#line 207 "../src/Document.vala"
	_tmp0_ = xmp_files_new ();
#line 207 "../src/Document.vala"
	xmp_file = _tmp0_;
#line 208 "../src/Document.vala"
	options = XMP_OPEN_FORUPDATE | XMP_OPEN_INBACKGROUND;
#line 209 "../src/Document.vala"
	_tmp1_ = g_file_new_for_uri (uri);
#line 209 "../src/Document.vala"
	file = _tmp1_;
#line 210 "../src/Document.vala"
	_tmp2_ = file;
#line 210 "../src/Document.vala"
	_tmp3_ = g_file_get_path (_tmp2_);
#line 210 "../src/Document.vala"
	path = _tmp3_;
#line 211 "../src/Document.vala"
	_tmp4_ = xmp_file;
#line 211 "../src/Document.vala"
	_tmp5_ = path;
#line 211 "../src/Document.vala"
	success = xmp_files_open (_tmp4_, _tmp5_, options);
#line 213 "../src/Document.vala"
	if (!success) {
#line 1354 "Document.c"
		gint _error_ = 0;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GError* _tmp12_;
		GError* _tmp13_;
#line 214 "../src/Document.vala"
		_error_ = xmp_get_error ();
#line 215 "../src/Document.vala"
		_tmp6_ = path;
#line 215 "../src/Document.vala"
		_tmp7_ = string_to_string (_tmp6_);
#line 215 "../src/Document.vala"
		_tmp8_ = g_strdup_printf ("%i", _error_);
#line 215 "../src/Document.vala"
		_tmp9_ = _tmp8_;
#line 215 "../src/Document.vala"
		_tmp10_ = g_strconcat ("Failed to open ", _tmp7_, " XMP metadata. Error: ", _tmp9_, NULL);
#line 215 "../src/Document.vala"
		_tmp11_ = _tmp10_;
#line 215 "../src/Document.vala"
		_tmp12_ = g_error_new_literal (PAPER_CLIP_XMP_ERROR, PAPER_CLIP_XMP_ERROR_FAILED_TO_OPEN, _tmp11_);
#line 215 "../src/Document.vala"
		_tmp13_ = _tmp12_;
#line 215 "../src/Document.vala"
		_g_free0 (_tmp11_);
#line 215 "../src/Document.vala"
		_g_free0 (_tmp9_);
#line 215 "../src/Document.vala"
		_inner_error0_ = _tmp13_;
#line 215 "../src/Document.vala"
		if (_inner_error0_->domain == PAPER_CLIP_XMP_ERROR) {
#line 215 "../src/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 215 "../src/Document.vala"
			_g_free0 (path);
#line 215 "../src/Document.vala"
			_g_object_unref0 (file);
#line 215 "../src/Document.vala"
			_xmp_files_free0 (xmp_file);
#line 215 "../src/Document.vala"
			return;
#line 1400 "Document.c"
		} else {
#line 215 "../src/Document.vala"
			_g_free0 (path);
#line 215 "../src/Document.vala"
			_g_object_unref0 (file);
#line 215 "../src/Document.vala"
			_xmp_files_free0 (xmp_file);
#line 215 "../src/Document.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 215 "../src/Document.vala"
			g_clear_error (&_inner_error0_);
#line 215 "../src/Document.vala"
			return;
#line 1414 "Document.c"
		}
	}
#line 218 "../src/Document.vala"
	_tmp14_ = xmp_new_empty ();
#line 218 "../src/Document.vala"
	xmp_meta = _tmp14_;
#line 219 "../src/Document.vala"
	_tmp15_ = xmp_file;
#line 219 "../src/Document.vala"
	_tmp16_ = xmp_meta;
#line 219 "../src/Document.vala"
	has_meta = xmp_files_get_xmp (_tmp15_, _tmp16_);
#line 220 "../src/Document.vala"
	if (!has_meta) {
#line 1429 "Document.c"
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		GError* _tmp21_;
		GError* _tmp22_;
#line 221 "../src/Document.vala"
		_tmp17_ = path;
#line 221 "../src/Document.vala"
		_tmp18_ = string_to_string (_tmp17_);
#line 221 "../src/Document.vala"
		_tmp19_ = g_strconcat (_tmp18_, " has no XMP Metadata", NULL);
#line 221 "../src/Document.vala"
		_tmp20_ = _tmp19_;
#line 221 "../src/Document.vala"
		_tmp21_ = g_error_new_literal (PAPER_CLIP_XMP_ERROR, PAPER_CLIP_XMP_ERROR_NO_XMP, _tmp20_);
#line 221 "../src/Document.vala"
		_tmp22_ = _tmp21_;
#line 221 "../src/Document.vala"
		_g_free0 (_tmp20_);
#line 221 "../src/Document.vala"
		_inner_error0_ = _tmp22_;
#line 221 "../src/Document.vala"
		if (_inner_error0_->domain == PAPER_CLIP_XMP_ERROR) {
#line 221 "../src/Document.vala"
			g_propagate_error (error, _inner_error0_);
#line 221 "../src/Document.vala"
			_xmp_free0 (xmp_meta);
#line 221 "../src/Document.vala"
			_g_free0 (path);
#line 221 "../src/Document.vala"
			_g_object_unref0 (file);
#line 221 "../src/Document.vala"
			_xmp_files_free0 (xmp_file);
#line 221 "../src/Document.vala"
			return;
#line 1466 "Document.c"
		} else {
#line 221 "../src/Document.vala"
			_xmp_free0 (xmp_meta);
#line 221 "../src/Document.vala"
			_g_free0 (path);
#line 221 "../src/Document.vala"
			_g_object_unref0 (file);
#line 221 "../src/Document.vala"
			_xmp_files_free0 (xmp_file);
#line 221 "../src/Document.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 221 "../src/Document.vala"
			g_clear_error (&_inner_error0_);
#line 221 "../src/Document.vala"
			return;
#line 1482 "Document.c"
		}
	}
#line 224 "../src/Document.vala"
	_tmp23_ = xmp_meta;
#line 224 "../src/Document.vala"
	_tmp24_ = paper_clip_document_get_producer (self);
#line 224 "../src/Document.vala"
	_tmp25_ = _tmp24_;
#line 224 "../src/Document.vala"
	_tmp26_ = _tmp25_;
#line 224 "../src/Document.vala"
	xmp_set_property (_tmp23_, NS_PDF, "Producer", _tmp26_, (guint32) 0x0);
#line 224 "../src/Document.vala"
	_g_free0 (_tmp26_);
#line 225 "../src/Document.vala"
	_tmp27_ = xmp_meta;
#line 225 "../src/Document.vala"
	_tmp28_ = paper_clip_document_get_creator (self);
#line 225 "../src/Document.vala"
	_tmp29_ = _tmp28_;
#line 225 "../src/Document.vala"
	_tmp30_ = _tmp29_;
#line 225 "../src/Document.vala"
	xmp_set_property (_tmp27_, NS_XAP, "CreatorTool", _tmp30_, (guint32) 0x0);
#line 225 "../src/Document.vala"
	_g_free0 (_tmp30_);
#line 226 "../src/Document.vala"
	_tmp31_ = xmp_meta;
#line 226 "../src/Document.vala"
	_tmp32_ = paper_clip_document_get_document (self);
#line 226 "../src/Document.vala"
	_tmp33_ = _tmp32_;
#line 226 "../src/Document.vala"
	_tmp34_ = poppler_document_get_keywords (_tmp33_);
#line 226 "../src/Document.vala"
	_tmp35_ = _tmp34_;
#line 226 "../src/Document.vala"
	_tmp36_ = _tmp35_;
#line 226 "../src/Document.vala"
	xmp_set_property (_tmp31_, NS_PDF, "Keywords", _tmp36_, (guint32) 0x0);
#line 226 "../src/Document.vala"
	_g_free0 (_tmp36_);
#line 228 "../src/Document.vala"
	_tmp37_ = xmp_meta;
#line 228 "../src/Document.vala"
	_tmp38_ = paper_clip_document_get_title (self);
#line 228 "../src/Document.vala"
	_tmp39_ = _tmp38_;
#line 228 "../src/Document.vala"
	_tmp40_ = _tmp39_;
#line 228 "../src/Document.vala"
	xmp_set_localized_text (_tmp37_, NS_DC, "title", "x", "x-default", _tmp40_, (guint32) 0x0);
#line 228 "../src/Document.vala"
	_g_free0 (_tmp40_);
#line 230 "../src/Document.vala"
	_tmp41_ = paper_clip_document_get_creation_date (self);
#line 230 "../src/Document.vala"
	_tmp42_ = _tmp41_;
#line 230 "../src/Document.vala"
	_tmp43_ = _tmp42_;
#line 230 "../src/Document.vala"
	_tmp44_ = _tmp43_ == NULL;
#line 230 "../src/Document.vala"
	_g_date_time_unref0 (_tmp43_);
#line 230 "../src/Document.vala"
	if (_tmp44_) {
#line 1549 "Document.c"
		struct _Xmp* _tmp45_;
#line 231 "../src/Document.vala"
		_tmp45_ = xmp_meta;
#line 231 "../src/Document.vala"
		xmp_delete_property (_tmp45_, NS_XAP, "CreateDate");
#line 1555 "Document.c"
	} else {
		struct _Xmp* _tmp46_;
		GDateTime* _tmp47_;
		GDateTime* _tmp48_;
		GDateTime* _tmp49_;
#line 233 "../src/Document.vala"
		_tmp46_ = xmp_meta;
#line 233 "../src/Document.vala"
		_tmp47_ = paper_clip_document_get_creation_date (self);
#line 233 "../src/Document.vala"
		_tmp48_ = _tmp47_;
#line 233 "../src/Document.vala"
		_tmp49_ = _tmp48_;
#line 233 "../src/Document.vala"
		__vala_xmp_set_property_date (_tmp46_, NS_XAP, "CreateDate", _tmp49_, (guint32) 0x0);
#line 233 "../src/Document.vala"
		_g_date_time_unref0 (_tmp49_);
#line 1573 "Document.c"
	}
#line 236 "../src/Document.vala"
	_tmp50_ = paper_clip_document_get_modification_date (self);
#line 236 "../src/Document.vala"
	_tmp51_ = _tmp50_;
#line 236 "../src/Document.vala"
	_tmp52_ = _tmp51_;
#line 236 "../src/Document.vala"
	_tmp53_ = _tmp52_ == NULL;
#line 236 "../src/Document.vala"
	_g_date_time_unref0 (_tmp52_);
#line 236 "../src/Document.vala"
	if (_tmp53_) {
#line 1587 "Document.c"
		struct _Xmp* _tmp54_;
#line 237 "../src/Document.vala"
		_tmp54_ = xmp_meta;
#line 237 "../src/Document.vala"
		xmp_delete_property (_tmp54_, NS_XAP, "ModifyDate");
#line 1593 "Document.c"
	} else {
		struct _Xmp* _tmp55_;
		GDateTime* _tmp56_;
		GDateTime* _tmp57_;
		GDateTime* _tmp58_;
#line 239 "../src/Document.vala"
		_tmp55_ = xmp_meta;
#line 239 "../src/Document.vala"
		_tmp56_ = paper_clip_document_get_modification_date (self);
#line 239 "../src/Document.vala"
		_tmp57_ = _tmp56_;
#line 239 "../src/Document.vala"
		_tmp58_ = _tmp57_;
#line 239 "../src/Document.vala"
		__vala_xmp_set_property_date (_tmp55_, NS_XAP, "ModifyDate", _tmp58_, (guint32) 0x0);
#line 239 "../src/Document.vala"
		_g_date_time_unref0 (_tmp58_);
#line 1611 "Document.c"
	}
#line 242 "../src/Document.vala"
	_tmp59_ = g_date_time_new_now_local ();
#line 242 "../src/Document.vala"
	metadata_date = _tmp59_;
#line 243 "../src/Document.vala"
	_tmp60_ = xmp_meta;
#line 243 "../src/Document.vala"
	_tmp61_ = metadata_date;
#line 243 "../src/Document.vala"
	__vala_xmp_set_property_date (_tmp60_, NS_XAP, "MetadataDate", _tmp61_, (guint32) 0x0);
#line 245 "../src/Document.vala"
	_tmp62_ = xmp_file;
#line 245 "../src/Document.vala"
	_tmp63_ = xmp_meta;
#line 245 "../src/Document.vala"
	if (xmp_files_can_put_xmp (_tmp62_, _tmp63_)) {
#line 1629 "Document.c"
		struct _XmpFile* _tmp64_;
		struct _Xmp* _tmp65_;
#line 246 "../src/Document.vala"
		g_debug ("Document.vala:246: Writing XMP Metadata");
#line 247 "../src/Document.vala"
		_tmp64_ = xmp_file;
#line 247 "../src/Document.vala"
		_tmp65_ = xmp_meta;
#line 247 "../src/Document.vala"
		xmp_files_put_xmp (_tmp64_, _tmp65_);
#line 1640 "Document.c"
	}
#line 249 "../src/Document.vala"
	_tmp66_ = xmp_file;
#line 249 "../src/Document.vala"
	xmp_files_close (_tmp66_, XMP_CLOSE_SAFEUPDATE);
#line 206 "../src/Document.vala"
	_g_date_time_unref0 (metadata_date);
#line 206 "../src/Document.vala"
	_xmp_free0 (xmp_meta);
#line 206 "../src/Document.vala"
	_g_free0 (path);
#line 206 "../src/Document.vala"
	_g_object_unref0 (file);
#line 206 "../src/Document.vala"
	_xmp_files_free0 (xmp_file);
#line 1656 "Document.c"
}

static void
__lambda4_ (PaperClipDocument* self)
{
#line 254 "../src/Document.vala"
	g_signal_emit (self, paper_clip_document_signals[PAPER_CLIP_DOCUMENT_KEYWORD_CHANGED_SIGNAL], 0);
#line 1664 "Document.c"
}

static void
___lambda4__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 254 "../src/Document.vala"
	__lambda4_ ((PaperClipDocument*) self);
#line 1674 "Document.c"
}

void
paper_clip_document_add_keyword (PaperClipDocument* self,
                                 const gchar* keyword)
{
	PaperClipStringObject* keyword_object = NULL;
	PaperClipStringObject* _tmp0_;
	GListStore* _tmp1_;
#line 252 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/Document.vala"
	g_return_if_fail (keyword != NULL);
#line 253 "../src/Document.vala"
	_tmp0_ = paper_clip_string_object_new (keyword);
#line 253 "../src/Document.vala"
	keyword_object = _tmp0_;
#line 254 "../src/Document.vala"
	g_signal_connect_object ((GObject*) keyword_object, "notify::str", (GCallback) ___lambda4__g_object_notify, self, 0);
#line 255 "../src/Document.vala"
	_tmp1_ = self->priv->keyword_list;
#line 255 "../src/Document.vala"
	g_list_store_append (_tmp1_, (GObject*) keyword_object);
#line 252 "../src/Document.vala"
	_g_object_unref0 (keyword_object);
#line 1700 "Document.c"
}

gboolean
paper_clip_document_remove_keyword (PaperClipDocument* self,
                                    const gchar* keyword)
{
	gboolean result;
#line 258 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 258 "../src/Document.vala"
	g_return_val_if_fail (keyword != NULL, FALSE);
#line 1712 "Document.c"
	{
		gint i = 0;
#line 259 "../src/Document.vala"
		i = 0;
#line 1717 "Document.c"
		{
			gboolean _tmp0_ = FALSE;
#line 259 "../src/Document.vala"
			_tmp0_ = TRUE;
#line 259 "../src/Document.vala"
			while (TRUE) {
#line 1724 "Document.c"
				GListStore* _tmp2_;
				PaperClipStringObject* item = NULL;
				GListStore* _tmp3_;
				GObject* _tmp4_;
				PaperClipStringObject* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 259 "../src/Document.vala"
				if (!_tmp0_) {
#line 1734 "Document.c"
					gint _tmp1_;
#line 259 "../src/Document.vala"
					_tmp1_ = i;
#line 259 "../src/Document.vala"
					i = _tmp1_ + 1;
#line 1740 "Document.c"
				}
#line 259 "../src/Document.vala"
				_tmp0_ = FALSE;
#line 259 "../src/Document.vala"
				_tmp2_ = self->priv->keyword_list;
#line 259 "../src/Document.vala"
				if (!(((guint) i) < g_list_model_get_n_items ((GListModel*) _tmp2_))) {
#line 259 "../src/Document.vala"
					break;
#line 1750 "Document.c"
				}
#line 260 "../src/Document.vala"
				_tmp3_ = self->priv->keyword_list;
#line 260 "../src/Document.vala"
				_tmp4_ = g_list_model_get_item ((GListModel*) _tmp3_, (guint) i);
#line 260 "../src/Document.vala"
				item = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, PAPER_CLIP_TYPE_STRING_OBJECT, PaperClipStringObject);
#line 261 "../src/Document.vala"
				_tmp5_ = item;
#line 261 "../src/Document.vala"
				_tmp6_ = paper_clip_string_object_get_str (_tmp5_);
#line 261 "../src/Document.vala"
				_tmp7_ = _tmp6_;
#line 261 "../src/Document.vala"
				if (g_strcmp0 (keyword, _tmp7_) == 0) {
#line 1766 "Document.c"
					GListStore* _tmp8_;
#line 262 "../src/Document.vala"
					_tmp8_ = self->priv->keyword_list;
#line 262 "../src/Document.vala"
					g_list_store_remove (_tmp8_, (guint) i);
#line 263 "../src/Document.vala"
					result = TRUE;
#line 263 "../src/Document.vala"
					_g_object_unref0 (item);
#line 263 "../src/Document.vala"
					return result;
#line 1778 "Document.c"
				}
#line 259 "../src/Document.vala"
				_g_object_unref0 (item);
#line 1782 "Document.c"
			}
		}
	}
#line 266 "../src/Document.vala"
	result = FALSE;
#line 266 "../src/Document.vala"
	return result;
#line 1790 "Document.c"
}

PopplerPage*
paper_clip_document_get_page_for_index (PaperClipDocument* self,
                                        gint index)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
	PopplerPage* _tmp2_;
	PopplerPage* result;
#line 269 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 270 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 270 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 270 "../src/Document.vala"
	_tmp2_ = poppler_document_get_page (_tmp1_, index);
#line 270 "../src/Document.vala"
	result = _tmp2_;
#line 270 "../src/Document.vala"
	return result;
#line 1813 "Document.c"
}

static void
paper_clip_document_deserialize_keywords (PaperClipDocument* self)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gchar** keyword_array = NULL;
	PopplerDocument* _tmp6_;
	PopplerDocument* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gint keyword_array_length1;
	gint _keyword_array_size_;
	gchar** _tmp14_;
	gint _tmp14__length1;
#line 273 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 274 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 274 "../src/Document.vala"
	_tmp2_ = poppler_document_get_keywords (_tmp1_);
#line 274 "../src/Document.vala"
	_tmp3_ = _tmp2_;
#line 274 "../src/Document.vala"
	_tmp4_ = _tmp3_;
#line 274 "../src/Document.vala"
	_tmp5_ = _tmp4_ == NULL;
#line 274 "../src/Document.vala"
	_g_free0 (_tmp4_);
#line 274 "../src/Document.vala"
	if (_tmp5_) {
#line 275 "../src/Document.vala"
		return;
#line 1859 "Document.c"
	}
#line 278 "../src/Document.vala"
	_tmp6_ = paper_clip_document_get_document (self);
#line 278 "../src/Document.vala"
	_tmp7_ = _tmp6_;
#line 278 "../src/Document.vala"
	_tmp8_ = poppler_document_get_keywords (_tmp7_);
#line 278 "../src/Document.vala"
	_tmp9_ = _tmp8_;
#line 278 "../src/Document.vala"
	_tmp10_ = _tmp9_;
#line 278 "../src/Document.vala"
	_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, ",", 0);
#line 278 "../src/Document.vala"
	_tmp13_ = _tmp12_;
#line 278 "../src/Document.vala"
	_tmp13__length1 = _vala_array_length (_tmp11_);
#line 278 "../src/Document.vala"
	_g_free0 (_tmp10_);
#line 278 "../src/Document.vala"
	keyword_array = _tmp13_;
#line 278 "../src/Document.vala"
	keyword_array_length1 = _tmp13__length1;
#line 278 "../src/Document.vala"
	_keyword_array_size_ = keyword_array_length1;
#line 279 "../src/Document.vala"
	_tmp14_ = keyword_array;
#line 279 "../src/Document.vala"
	_tmp14__length1 = keyword_array_length1;
#line 1889 "Document.c"
	{
		gchar** keyword_collection = NULL;
		gint keyword_collection_length1 = 0;
		gint _keyword_collection_size_ = 0;
		gint keyword_it = 0;
#line 279 "../src/Document.vala"
		keyword_collection = _tmp14_;
#line 279 "../src/Document.vala"
		keyword_collection_length1 = _tmp14__length1;
#line 279 "../src/Document.vala"
		for (keyword_it = 0; keyword_it < keyword_collection_length1; keyword_it = keyword_it + 1) {
#line 1901 "Document.c"
			gchar* _tmp15_;
			gchar* keyword = NULL;
#line 279 "../src/Document.vala"
			_tmp15_ = g_strdup (keyword_collection[keyword_it]);
#line 279 "../src/Document.vala"
			keyword = _tmp15_;
#line 1908 "Document.c"
			{
				const gchar* _tmp16_;
#line 280 "../src/Document.vala"
				_tmp16_ = keyword;
#line 280 "../src/Document.vala"
				paper_clip_document_add_keyword (self, _tmp16_);
#line 279 "../src/Document.vala"
				_g_free0 (keyword);
#line 1917 "Document.c"
			}
		}
	}
#line 273 "../src/Document.vala"
	keyword_array = (_vala_array_free (keyword_array, keyword_array_length1, (GDestroyNotify) g_free), NULL);
#line 1923 "Document.c"
}

static gchar*
paper_clip_document_serialize_keywords (PaperClipDocument* self)
{
	gchar* format = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 284 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 285 "../src/Document.vala"
	_tmp0_ = g_strdup ("");
#line 285 "../src/Document.vala"
	format = _tmp0_;
#line 1938 "Document.c"
	{
		gint i = 0;
#line 286 "../src/Document.vala"
		i = 0;
#line 1943 "Document.c"
		{
			gboolean _tmp1_ = FALSE;
#line 286 "../src/Document.vala"
			_tmp1_ = TRUE;
#line 286 "../src/Document.vala"
			while (TRUE) {
#line 1950 "Document.c"
				GListStore* _tmp3_;
				PaperClipStringObject* item = NULL;
				GListStore* _tmp4_;
				GObject* _tmp5_;
				const gchar* _tmp6_;
				PaperClipStringObject* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				GListModel* _tmp13_;
				GListModel* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
#line 286 "../src/Document.vala"
				if (!_tmp1_) {
#line 1968 "Document.c"
					gint _tmp2_;
#line 286 "../src/Document.vala"
					_tmp2_ = i;
#line 286 "../src/Document.vala"
					i = _tmp2_ + 1;
#line 1974 "Document.c"
				}
#line 286 "../src/Document.vala"
				_tmp1_ = FALSE;
#line 286 "../src/Document.vala"
				_tmp3_ = self->priv->keyword_list;
#line 286 "../src/Document.vala"
				if (!(((guint) i) < g_list_model_get_n_items ((GListModel*) _tmp3_))) {
#line 286 "../src/Document.vala"
					break;
#line 1984 "Document.c"
				}
#line 287 "../src/Document.vala"
				_tmp4_ = self->priv->keyword_list;
#line 287 "../src/Document.vala"
				_tmp5_ = g_list_model_get_item ((GListModel*) _tmp4_, (guint) i);
#line 287 "../src/Document.vala"
				item = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, PAPER_CLIP_TYPE_STRING_OBJECT, PaperClipStringObject);
#line 288 "../src/Document.vala"
				_tmp6_ = format;
#line 288 "../src/Document.vala"
				_tmp7_ = item;
#line 288 "../src/Document.vala"
				_tmp8_ = paper_clip_string_object_get_str (_tmp7_);
#line 288 "../src/Document.vala"
				_tmp9_ = _tmp8_;
#line 288 "../src/Document.vala"
				_tmp10_ = g_strdup_printf ("%s", _tmp9_);
#line 288 "../src/Document.vala"
				_tmp11_ = _tmp10_;
#line 288 "../src/Document.vala"
				_tmp12_ = g_strconcat (_tmp6_, _tmp11_, NULL);
#line 288 "../src/Document.vala"
				_g_free0 (format);
#line 288 "../src/Document.vala"
				format = _tmp12_;
#line 288 "../src/Document.vala"
				_g_free0 (_tmp11_);
#line 289 "../src/Document.vala"
				_tmp13_ = paper_clip_document_get_keywords (self);
#line 289 "../src/Document.vala"
				_tmp14_ = _tmp13_;
#line 289 "../src/Document.vala"
				if (((guint) i) == (g_list_model_get_n_items (_tmp14_) - 1)) {
#line 290 "../src/Document.vala"
					_g_object_unref0 (item);
#line 290 "../src/Document.vala"
					break;
#line 2022 "Document.c"
				}
#line 292 "../src/Document.vala"
				_tmp15_ = format;
#line 292 "../src/Document.vala"
				_tmp16_ = g_strconcat (_tmp15_, ",", NULL);
#line 292 "../src/Document.vala"
				_g_free0 (format);
#line 292 "../src/Document.vala"
				format = _tmp16_;
#line 286 "../src/Document.vala"
				_g_object_unref0 (item);
#line 2034 "Document.c"
			}
		}
	}
#line 294 "../src/Document.vala"
	result = format;
#line 294 "../src/Document.vala"
	return result;
#line 2042 "Document.c"
}

static gchar*
paper_clip_document_layout_to_string (PaperClipDocument* self)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
	PopplerPageLayout _tmp2_;
	PopplerPageLayout _tmp3_;
	gchar* result;
#line 297 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 298 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 298 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 298 "../src/Document.vala"
	_tmp2_ = poppler_document_get_page_layout (_tmp1_);
#line 298 "../src/Document.vala"
	_tmp3_ = _tmp2_;
#line 298 "../src/Document.vala"
	switch (_tmp3_) {
#line 298 "../src/Document.vala"
		case POPPLER_PAGE_LAYOUT_ONE_COLUMN:
#line 2067 "Document.c"
		{
			gchar* _tmp4_;
#line 300 "../src/Document.vala"
			_tmp4_ = g_strdup (_ ("Pages in one column"));
#line 300 "../src/Document.vala"
			result = _tmp4_;
#line 300 "../src/Document.vala"
			return result;
#line 2076 "Document.c"
		}
#line 298 "../src/Document.vala"
		case POPPLER_PAGE_LAYOUT_SINGLE_PAGE:
#line 2080 "Document.c"
		{
			gchar* _tmp5_;
#line 303 "../src/Document.vala"
			_tmp5_ = g_strdup (_ ("One page at a time"));
#line 303 "../src/Document.vala"
			result = _tmp5_;
#line 303 "../src/Document.vala"
			return result;
#line 2089 "Document.c"
		}
#line 298 "../src/Document.vala"
		case POPPLER_PAGE_LAYOUT_TWO_COLUMN_LEFT:
#line 2093 "Document.c"
		{
			gchar* _tmp6_;
#line 306 "../src/Document.vala"
			_tmp6_ = g_strdup (_ ("Odd numbered pages on the left"));
#line 306 "../src/Document.vala"
			result = _tmp6_;
#line 306 "../src/Document.vala"
			return result;
#line 2102 "Document.c"
		}
#line 298 "../src/Document.vala"
		case POPPLER_PAGE_LAYOUT_TWO_COLUMN_RIGHT:
#line 2106 "Document.c"
		{
			gchar* _tmp7_;
#line 309 "../src/Document.vala"
			_tmp7_ = g_strdup (_ ("Odd numbered pages on the right"));
#line 309 "../src/Document.vala"
			result = _tmp7_;
#line 309 "../src/Document.vala"
			return result;
#line 2115 "Document.c"
		}
#line 298 "../src/Document.vala"
		case POPPLER_PAGE_LAYOUT_TWO_PAGE_LEFT:
#line 2119 "Document.c"
		{
			gchar* _tmp8_;
#line 312 "../src/Document.vala"
			_tmp8_ = g_strdup (_ ("Two odd numbered pages on the left"));
#line 312 "../src/Document.vala"
			result = _tmp8_;
#line 312 "../src/Document.vala"
			return result;
#line 2128 "Document.c"
		}
#line 298 "../src/Document.vala"
		case POPPLER_PAGE_LAYOUT_TWO_PAGE_RIGHT:
#line 2132 "Document.c"
		{
			gchar* _tmp9_;
#line 315 "../src/Document.vala"
			_tmp9_ = g_strdup (_ ("Two odd numbered pages on the right"));
#line 315 "../src/Document.vala"
			result = _tmp9_;
#line 315 "../src/Document.vala"
			return result;
#line 2141 "Document.c"
		}
		default:
#line 298 "../src/Document.vala"
		case POPPLER_PAGE_LAYOUT_UNSET:
#line 2146 "Document.c"
		{
			gchar* _tmp10_;
#line 319 "../src/Document.vala"
			_tmp10_ = g_strdup (_ ("No specific layout"));
#line 319 "../src/Document.vala"
			result = _tmp10_;
#line 319 "../src/Document.vala"
			return result;
#line 2155 "Document.c"
		}
	}
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 328 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 328 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 328 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2172 "Document.c"
	}
#line 328 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 328 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2178 "Document.c"
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 332 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 332 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 332 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2193 "Document.c"
	}
#line 332 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 332 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2199 "Document.c"
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 336 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 336 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 336 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2214 "Document.c"
	}
#line 336 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 336 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2220 "Document.c"
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 340 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 340 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 340 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2235 "Document.c"
	}
#line 340 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 340 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2241 "Document.c"
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 344 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 344 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 344 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2256 "Document.c"
	}
#line 344 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 344 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2262 "Document.c"
}

static void
_vala_array_add7 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 348 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 348 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 348 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2277 "Document.c"
	}
#line 348 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 348 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2283 "Document.c"
}

static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 352 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 352 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 352 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2298 "Document.c"
	}
#line 352 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 352 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2304 "Document.c"
}

static void
_vala_array_add9 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 356 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 356 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 356 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2319 "Document.c"
	}
#line 356 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 356 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2325 "Document.c"
}

static gchar**
paper_clip_document_viewer_preferences_to_string_array (PaperClipDocument* self,
                                                        gint* result_length1)
{
	gchar** preferences_array = NULL;
	gchar** _tmp0_;
	gint preferences_array_length1;
	gint _preferences_array_size_;
	PopplerViewerPreferences preferences = 0U;
	PopplerDocument* _tmp1_;
	PopplerDocument* _tmp2_;
	PopplerViewerPreferences _tmp3_;
	PopplerViewerPreferences _tmp4_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar** result;
#line 323 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 324 "../src/Document.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 324 "../src/Document.vala"
	preferences_array = _tmp0_;
#line 324 "../src/Document.vala"
	preferences_array_length1 = 0;
#line 324 "../src/Document.vala"
	_preferences_array_size_ = preferences_array_length1;
#line 325 "../src/Document.vala"
	_tmp1_ = paper_clip_document_get_document (self);
#line 325 "../src/Document.vala"
	_tmp2_ = _tmp1_;
#line 325 "../src/Document.vala"
	g_object_get (_tmp2_, "viewer-preferences", &_tmp3_, NULL);
#line 325 "../src/Document.vala"
	_tmp4_ = _tmp3_;
#line 325 "../src/Document.vala"
	preferences = _tmp4_;
#line 327 "../src/Document.vala"
	if ((preferences & POPPLER_VIEWER_PREFERENCES_CENTER_WINDOW) == POPPLER_VIEWER_PREFERENCES_CENTER_WINDOW) {
#line 2366 "Document.c"
		gchar* _tmp5_;
#line 328 "../src/Document.vala"
		_tmp5_ = g_strdup (_ ("Center document's window"));
#line 328 "../src/Document.vala"
		_vala_array_add2 (&preferences_array, &preferences_array_length1, &_preferences_array_size_, _tmp5_);
#line 2372 "Document.c"
	}
#line 331 "../src/Document.vala"
	if ((preferences & POPPLER_VIEWER_PREFERENCES_DIRECTION_RTL) == POPPLER_VIEWER_PREFERENCES_DIRECTION_RTL) {
#line 2376 "Document.c"
		gchar* _tmp6_;
#line 332 "../src/Document.vala"
		_tmp6_ = g_strdup (_ ("Reading order is right to left"));
#line 332 "../src/Document.vala"
		_vala_array_add3 (&preferences_array, &preferences_array_length1, &_preferences_array_size_, _tmp6_);
#line 2382 "Document.c"
	}
#line 335 "../src/Document.vala"
	if ((preferences & POPPLER_VIEWER_PREFERENCES_DISPLAY_DOC_TITLE) == POPPLER_VIEWER_PREFERENCES_DISPLAY_DOC_TITLE) {
#line 2386 "Document.c"
		gchar* _tmp7_;
#line 336 "../src/Document.vala"
		_tmp7_ = g_strdup (_ ("Display document's title"));
#line 336 "../src/Document.vala"
		_vala_array_add4 (&preferences_array, &preferences_array_length1, &_preferences_array_size_, _tmp7_);
#line 2392 "Document.c"
	}
#line 339 "../src/Document.vala"
	if ((preferences & POPPLER_VIEWER_PREFERENCES_FIT_WINDOW) == POPPLER_VIEWER_PREFERENCES_FIT_WINDOW) {
#line 2396 "Document.c"
		gchar* _tmp8_;
#line 340 "../src/Document.vala"
		_tmp8_ = g_strdup (_ ("Fit document to window"));
#line 340 "../src/Document.vala"
		_vala_array_add5 (&preferences_array, &preferences_array_length1, &_preferences_array_size_, _tmp8_);
#line 2402 "Document.c"
	}
#line 343 "../src/Document.vala"
	if ((preferences & POPPLER_VIEWER_PREFERENCES_HIDE_MENUBAR) == POPPLER_VIEWER_PREFERENCES_HIDE_MENUBAR) {
#line 2406 "Document.c"
		gchar* _tmp9_;
#line 344 "../src/Document.vala"
		_tmp9_ = g_strdup (_ ("Hide window menubar"));
#line 344 "../src/Document.vala"
		_vala_array_add6 (&preferences_array, &preferences_array_length1, &_preferences_array_size_, _tmp9_);
#line 2412 "Document.c"
	}
#line 347 "../src/Document.vala"
	if ((preferences & POPPLER_VIEWER_PREFERENCES_HIDE_TOOLBAR) == POPPLER_VIEWER_PREFERENCES_HIDE_TOOLBAR) {
#line 2416 "Document.c"
		gchar* _tmp10_;
#line 348 "../src/Document.vala"
		_tmp10_ = g_strdup (_ ("Hide window toolbars"));
#line 348 "../src/Document.vala"
		_vala_array_add7 (&preferences_array, &preferences_array_length1, &_preferences_array_size_, _tmp10_);
#line 2422 "Document.c"
	}
#line 351 "../src/Document.vala"
	if ((preferences & POPPLER_VIEWER_PREFERENCES_HIDE_WINDOWUI) == POPPLER_VIEWER_PREFERENCES_HIDE_WINDOWUI) {
#line 2426 "Document.c"
		gchar* _tmp11_;
#line 352 "../src/Document.vala"
		_tmp11_ = g_strdup (_ ("Hide UI elements"));
#line 352 "../src/Document.vala"
		_vala_array_add8 (&preferences_array, &preferences_array_length1, &_preferences_array_size_, _tmp11_);
#line 2432 "Document.c"
	}
#line 355 "../src/Document.vala"
	if ((preferences & POPPLER_VIEWER_PREFERENCES_UNSET) == POPPLER_VIEWER_PREFERENCES_UNSET) {
#line 2436 "Document.c"
		gchar* _tmp12_;
#line 356 "../src/Document.vala"
		_tmp12_ = g_strdup (_ ("No preferences"));
#line 356 "../src/Document.vala"
		_vala_array_add9 (&preferences_array, &preferences_array_length1, &_preferences_array_size_, _tmp12_);
#line 2442 "Document.c"
	}
#line 359 "../src/Document.vala"
	_tmp13_ = preferences_array;
#line 359 "../src/Document.vala"
	_tmp13__length1 = preferences_array_length1;
#line 359 "../src/Document.vala"
	if (result_length1) {
#line 359 "../src/Document.vala"
		*result_length1 = _tmp13__length1;
#line 2452 "Document.c"
	}
#line 359 "../src/Document.vala"
	result = _tmp13_;
#line 359 "../src/Document.vala"
	return result;
#line 2458 "Document.c"
}

static void
_vala_array_add10 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 367 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 367 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 367 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2473 "Document.c"
	}
#line 367 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 367 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2479 "Document.c"
}

static void
_vala_array_add11 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 371 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 371 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 371 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2494 "Document.c"
	}
#line 371 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 371 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2500 "Document.c"
}

static void
_vala_array_add12 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 375 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 375 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 375 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2515 "Document.c"
	}
#line 375 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 375 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2521 "Document.c"
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 379 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 379 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 379 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2536 "Document.c"
	}
#line 379 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 379 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2542 "Document.c"
}

static void
_vala_array_add14 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 383 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 383 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 383 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2557 "Document.c"
	}
#line 383 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 383 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2563 "Document.c"
}

static void
_vala_array_add15 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 387 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 387 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 387 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2578 "Document.c"
	}
#line 387 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 387 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2584 "Document.c"
}

static void
_vala_array_add16 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 391 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 391 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 391 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2599 "Document.c"
	}
#line 391 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 391 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2605 "Document.c"
}

static void
_vala_array_add17 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 395 "../src/Document.vala"
	if ((*length) == (*size)) {
#line 395 "../src/Document.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 395 "../src/Document.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2620 "Document.c"
	}
#line 395 "../src/Document.vala"
	(*array)[(*length)++] = value;
#line 395 "../src/Document.vala"
	(*array)[*length] = NULL;
#line 2626 "Document.c"
}

static gchar**
paper_clip_document_permissions_to_string_array (PaperClipDocument* self,
                                                 gint* result_length1)
{
	gchar** permission_array = NULL;
	gchar** _tmp0_;
	gint permission_array_length1;
	gint _permission_array_size_;
	PopplerPermissions permission_flags = 0U;
	PopplerDocument* _tmp1_;
	PopplerDocument* _tmp2_;
	PopplerPermissions _tmp3_;
	PopplerPermissions _tmp4_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar** result;
#line 362 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 363 "../src/Document.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 363 "../src/Document.vala"
	permission_array = _tmp0_;
#line 363 "../src/Document.vala"
	permission_array_length1 = 0;
#line 363 "../src/Document.vala"
	_permission_array_size_ = permission_array_length1;
#line 364 "../src/Document.vala"
	_tmp1_ = paper_clip_document_get_document (self);
#line 364 "../src/Document.vala"
	_tmp2_ = _tmp1_;
#line 364 "../src/Document.vala"
	_tmp3_ = poppler_document_get_permissions (_tmp2_);
#line 364 "../src/Document.vala"
	_tmp4_ = _tmp3_;
#line 364 "../src/Document.vala"
	permission_flags = _tmp4_;
#line 366 "../src/Document.vala"
	if ((permission_flags & POPPLER_PERMISSIONS_OK_TO_ADD_NOTES) == POPPLER_PERMISSIONS_OK_TO_ADD_NOTES) {
#line 2667 "Document.c"
		gchar* _tmp5_;
#line 367 "../src/Document.vala"
		_tmp5_ = g_strdup (_ ("Adding notes"));
#line 367 "../src/Document.vala"
		_vala_array_add10 (&permission_array, &permission_array_length1, &_permission_array_size_, _tmp5_);
#line 2673 "Document.c"
	}
#line 370 "../src/Document.vala"
	if ((permission_flags & POPPLER_PERMISSIONS_OK_TO_ASSEMBLE) == POPPLER_PERMISSIONS_OK_TO_ASSEMBLE) {
#line 2677 "Document.c"
		gchar* _tmp6_;
#line 371 "../src/Document.vala"
		_tmp6_ = g_strdup (_ ("Inserting elements"));
#line 371 "../src/Document.vala"
		_vala_array_add11 (&permission_array, &permission_array_length1, &_permission_array_size_, _tmp6_);
#line 2683 "Document.c"
	}
#line 374 "../src/Document.vala"
	if ((permission_flags & POPPLER_PERMISSIONS_OK_TO_COPY) == POPPLER_PERMISSIONS_OK_TO_COPY) {
#line 2687 "Document.c"
		gchar* _tmp7_;
#line 375 "../src/Document.vala"
		_tmp7_ = g_strdup (_ ("Copying"));
#line 375 "../src/Document.vala"
		_vala_array_add12 (&permission_array, &permission_array_length1, &_permission_array_size_, _tmp7_);
#line 2693 "Document.c"
	}
#line 378 "../src/Document.vala"
	if ((permission_flags & POPPLER_PERMISSIONS_OK_TO_EXTRACT_CONTENTS) == POPPLER_PERMISSIONS_OK_TO_EXTRACT_CONTENTS) {
#line 2697 "Document.c"
		gchar* _tmp8_;
#line 379 "../src/Document.vala"
		_tmp8_ = g_strdup (_ ("Extracting contents"));
#line 379 "../src/Document.vala"
		_vala_array_add13 (&permission_array, &permission_array_length1, &_permission_array_size_, _tmp8_);
#line 2703 "Document.c"
	}
#line 382 "../src/Document.vala"
	if ((permission_flags & POPPLER_PERMISSIONS_OK_TO_FILL_FORM) == POPPLER_PERMISSIONS_OK_TO_FILL_FORM) {
#line 2707 "Document.c"
		gchar* _tmp9_;
#line 383 "../src/Document.vala"
		_tmp9_ = g_strdup (_ ("Filling interactive forms"));
#line 383 "../src/Document.vala"
		_vala_array_add14 (&permission_array, &permission_array_length1, &_permission_array_size_, _tmp9_);
#line 2713 "Document.c"
	}
#line 386 "../src/Document.vala"
	if ((permission_flags & POPPLER_PERMISSIONS_OK_TO_MODIFY) == POPPLER_PERMISSIONS_OK_TO_MODIFY) {
#line 2717 "Document.c"
		gchar* _tmp10_;
#line 387 "../src/Document.vala"
		_tmp10_ = g_strdup (_ ("Modifying"));
#line 387 "../src/Document.vala"
		_vala_array_add15 (&permission_array, &permission_array_length1, &_permission_array_size_, _tmp10_);
#line 2723 "Document.c"
	}
#line 390 "../src/Document.vala"
	if ((permission_flags & POPPLER_PERMISSIONS_OK_TO_PRINT) == POPPLER_PERMISSIONS_OK_TO_PRINT) {
#line 2727 "Document.c"
		gchar* _tmp11_;
#line 391 "../src/Document.vala"
		_tmp11_ = g_strdup (_ ("Printing"));
#line 391 "../src/Document.vala"
		_vala_array_add16 (&permission_array, &permission_array_length1, &_permission_array_size_, _tmp11_);
#line 2733 "Document.c"
	}
#line 394 "../src/Document.vala"
	if ((permission_flags & POPPLER_PERMISSIONS_OK_TO_PRINT_HIGH_RESOLUTION) == POPPLER_PERMISSIONS_OK_TO_PRINT_HIGH_RESOLUTION) {
#line 2737 "Document.c"
		gchar* _tmp12_;
#line 395 "../src/Document.vala"
		_tmp12_ = g_strdup (_ ("Printing in high resolution"));
#line 395 "../src/Document.vala"
		_vala_array_add17 (&permission_array, &permission_array_length1, &_permission_array_size_, _tmp12_);
#line 2743 "Document.c"
	}
#line 398 "../src/Document.vala"
	_tmp13_ = permission_array;
#line 398 "../src/Document.vala"
	_tmp13__length1 = permission_array_length1;
#line 398 "../src/Document.vala"
	if (result_length1) {
#line 398 "../src/Document.vala"
		*result_length1 = _tmp13__length1;
#line 2753 "Document.c"
	}
#line 398 "../src/Document.vala"
	result = _tmp13_;
#line 398 "../src/Document.vala"
	return result;
#line 2759 "Document.c"
}

static gchar*
paper_clip_document_print_duplex_to_string (PaperClipDocument* self)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
	PopplerPrintDuplex _tmp2_;
	PopplerPrintDuplex _tmp3_;
	gchar* result;
#line 401 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 402 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 402 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 402 "../src/Document.vala"
	_tmp2_ = poppler_document_get_print_duplex (_tmp1_);
#line 402 "../src/Document.vala"
	_tmp3_ = _tmp2_;
#line 402 "../src/Document.vala"
	switch (_tmp3_) {
#line 402 "../src/Document.vala"
		case POPPLER_PRINT_DUPLEX_DUPLEX_FLIP_LONG_EDGE:
#line 2784 "Document.c"
		{
			gchar* _tmp4_;
#line 404 "../src/Document.vala"
			_tmp4_ = g_strdup (_ ("Flip on the long edge"));
#line 404 "../src/Document.vala"
			result = _tmp4_;
#line 404 "../src/Document.vala"
			return result;
#line 2793 "Document.c"
		}
#line 402 "../src/Document.vala"
		case POPPLER_PRINT_DUPLEX_DUPLEX_FLIP_SHORT_EDGE:
#line 2797 "Document.c"
		{
			gchar* _tmp5_;
#line 407 "../src/Document.vala"
			_tmp5_ = g_strdup (_ ("Flip on the short edge"));
#line 407 "../src/Document.vala"
			result = _tmp5_;
#line 407 "../src/Document.vala"
			return result;
#line 2806 "Document.c"
		}
#line 402 "../src/Document.vala"
		case POPPLER_PRINT_DUPLEX_SIMPLEX:
#line 2810 "Document.c"
		{
			gchar* _tmp6_;
#line 410 "../src/Document.vala"
			_tmp6_ = g_strdup (_ ("Only single sided"));
#line 410 "../src/Document.vala"
			result = _tmp6_;
#line 410 "../src/Document.vala"
			return result;
#line 2819 "Document.c"
		}
		default:
#line 402 "../src/Document.vala"
		case POPPLER_PRINT_DUPLEX_NONE:
#line 2824 "Document.c"
		{
			gchar* _tmp7_;
#line 414 "../src/Document.vala"
			_tmp7_ = g_strdup (_ ("No preference"));
#line 414 "../src/Document.vala"
			result = _tmp7_;
#line 414 "../src/Document.vala"
			return result;
#line 2833 "Document.c"
		}
	}
}

static gchar*
paper_clip_document_subtype_to_string (PaperClipDocument* self)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
	PopplerPDFSubtype _tmp2_;
	PopplerPDFSubtype _tmp3_;
	gchar* result;
#line 418 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 419 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 419 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 419 "../src/Document.vala"
	g_object_get (_tmp1_, "subtype", &_tmp2_, NULL);
#line 419 "../src/Document.vala"
	_tmp3_ = _tmp2_;
#line 419 "../src/Document.vala"
	switch (_tmp3_) {
#line 419 "../src/Document.vala"
		case POPPLER_PDF_SUBTYPE_PDF_A:
#line 2860 "Document.c"
		{
			gchar* _tmp4_;
#line 421 "../src/Document.vala"
			_tmp4_ = g_strdup ("ISO 19005");
#line 421 "../src/Document.vala"
			result = _tmp4_;
#line 421 "../src/Document.vala"
			return result;
#line 2869 "Document.c"
		}
#line 419 "../src/Document.vala"
		case POPPLER_PDF_SUBTYPE_PDF_E:
#line 2873 "Document.c"
		{
			gchar* _tmp5_;
#line 424 "../src/Document.vala"
			_tmp5_ = g_strdup ("ISO 24517");
#line 424 "../src/Document.vala"
			result = _tmp5_;
#line 424 "../src/Document.vala"
			return result;
#line 2882 "Document.c"
		}
#line 419 "../src/Document.vala"
		case POPPLER_PDF_SUBTYPE_PDF_UA:
#line 2886 "Document.c"
		{
			gchar* _tmp6_;
#line 427 "../src/Document.vala"
			_tmp6_ = g_strdup ("ISO 14289");
#line 427 "../src/Document.vala"
			result = _tmp6_;
#line 427 "../src/Document.vala"
			return result;
#line 2895 "Document.c"
		}
#line 419 "../src/Document.vala"
		case POPPLER_PDF_SUBTYPE_PDF_VT:
#line 2899 "Document.c"
		{
			gchar* _tmp7_;
#line 430 "../src/Document.vala"
			_tmp7_ = g_strdup ("ISO 16612");
#line 430 "../src/Document.vala"
			result = _tmp7_;
#line 430 "../src/Document.vala"
			return result;
#line 2908 "Document.c"
		}
#line 419 "../src/Document.vala"
		case POPPLER_PDF_SUBTYPE_PDF_X:
#line 2912 "Document.c"
		{
			gchar* _tmp8_;
#line 433 "../src/Document.vala"
			_tmp8_ = g_strdup ("ISO 15930");
#line 433 "../src/Document.vala"
			result = _tmp8_;
#line 433 "../src/Document.vala"
			return result;
#line 2921 "Document.c"
		}
		default:
#line 419 "../src/Document.vala"
		case POPPLER_PDF_SUBTYPE_UNSET:
#line 419 "../src/Document.vala"
		case POPPLER_PDF_SUBTYPE_NONE:
#line 2928 "Document.c"
		{
			gchar* _tmp9_;
#line 438 "../src/Document.vala"
			_tmp9_ = g_strdup (_ ("Not compliant"));
#line 438 "../src/Document.vala"
			result = _tmp9_;
#line 438 "../src/Document.vala"
			return result;
#line 2937 "Document.c"
		}
	}
}

static void
paper_clip_document_load_document_data_free (gpointer _data)
{
	PaperClipDocumentLoadDocumentData* _data_;
	_data_ = _data;
#line 21 "../src/Document.vala"
	_g_free0 (_data_->password);
#line 21 "../src/Document.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/Document.vala"
	g_slice_free (PaperClipDocumentLoadDocumentData, _data_);
#line 2953 "Document.c"
}

static void
paper_clip_document_load_document (PaperClipDocument* self,
                                   const gchar* password,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	PaperClipDocumentLoadDocumentData* _data_;
	PaperClipDocument* _tmp0_;
	gchar* _tmp1_;
#line 21 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Document.vala"
	_data_ = g_slice_new0 (PaperClipDocumentLoadDocumentData);
#line 21 "../src/Document.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/Document.vala"
	g_task_set_task_data (_data_->_async_result, _data_, paper_clip_document_load_document_data_free);
#line 21 "../src/Document.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/Document.vala"
	_data_->self = _tmp0_;
#line 21 "../src/Document.vala"
	_tmp1_ = g_strdup (password);
#line 21 "../src/Document.vala"
	_g_free0 (_data_->password);
#line 21 "../src/Document.vala"
	_data_->password = _tmp1_;
#line 21 "../src/Document.vala"
	paper_clip_document_load_document_co (_data_);
#line 2985 "Document.c"
}

static void
paper_clip_document_load_document_finish (PaperClipDocument* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	PaperClipDocumentLoadDocumentData* _data_;
#line 21 "../src/Document.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 21 "../src/Document.vala"
	if (NULL == _data_) {
#line 21 "../src/Document.vala"
		return;
#line 3000 "Document.c"
	}
}

static void
paper_clip_document_load_document_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	PaperClipDocumentLoadDocumentData* _data_;
#line 443 "../src/Document.vala"
	_data_ = _user_data_;
#line 443 "../src/Document.vala"
	_data_->_source_object_ = source_object;
#line 443 "../src/Document.vala"
	_data_->_res_ = _res_;
#line 443 "../src/Document.vala"
	paper_clip_document_load_document_co (_data_);
#line 3018 "Document.c"
}

static gboolean
paper_clip_document_load_document_co (PaperClipDocumentLoadDocumentData* _data_)
{
#line 442 "../src/Document.vala"
	switch (_data_->_state_) {
#line 442 "../src/Document.vala"
		case 0:
#line 3028 "Document.c"
		goto _state_0;
#line 442 "../src/Document.vala"
		case 1:
#line 3032 "Document.c"
		goto _state_1;
		default:
#line 442 "../src/Document.vala"
		g_assert_not_reached ();
#line 3037 "Document.c"
	}
	_state_0:
#line 443 "../src/Document.vala"
	_data_->_state_ = 1;
#line 443 "../src/Document.vala"
	paper_clip_document_create_copy_from_original (_data_->self, paper_clip_document_load_document_ready, _data_);
#line 443 "../src/Document.vala"
	return FALSE;
#line 3046 "Document.c"
	_state_1:
#line 443 "../src/Document.vala"
	_data_->_tmp1_ = paper_clip_document_create_copy_from_original_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 443 "../src/Document.vala"
	_data_->_tmp0_ = _data_->_tmp1_;
#line 443 "../src/Document.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 443 "../src/Document.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 443 "../src/Document.vala"
		g_object_unref (_data_->_async_result);
#line 443 "../src/Document.vala"
		return FALSE;
#line 3060 "Document.c"
	}
#line 443 "../src/Document.vala"
	paper_clip_document_set_cached_file (_data_->self, _data_->_tmp0_);
#line 444 "../src/Document.vala"
	_data_->_tmp3_ = _data_->self->priv->_cached_file;
#line 444 "../src/Document.vala"
	_data_->_tmp4_ = poppler_document_new_from_gfile (_data_->_tmp3_, _data_->password, NULL, &_data_->_inner_error0_);
#line 444 "../src/Document.vala"
	_data_->_tmp2_ = _data_->_tmp4_;
#line 444 "../src/Document.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 444 "../src/Document.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 444 "../src/Document.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 444 "../src/Document.vala"
		g_object_unref (_data_->_async_result);
#line 444 "../src/Document.vala"
		return FALSE;
#line 3080 "Document.c"
	}
#line 444 "../src/Document.vala"
	paper_clip_document_set_document (_data_->self, _data_->_tmp2_);
#line 442 "../src/Document.vala"
	_g_object_unref0 (_data_->_tmp2_);
#line 442 "../src/Document.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 442 "../src/Document.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 442 "../src/Document.vala"
	if (_data_->_state_ != 0) {
#line 442 "../src/Document.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 442 "../src/Document.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3096 "Document.c"
		}
	}
#line 442 "../src/Document.vala"
	g_object_unref (_data_->_async_result);
#line 442 "../src/Document.vala"
	return FALSE;
#line 3103 "Document.c"
}

static void
paper_clip_document_create_copy_from_original_data_free (gpointer _data)
{
	PaperClipDocumentCreateCopyFromOriginalData* _data_;
	_data_ = _data;
#line 21 "../src/Document.vala"
	_g_object_unref0 (_data_->result);
#line 21 "../src/Document.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../src/Document.vala"
	g_slice_free (PaperClipDocumentCreateCopyFromOriginalData, _data_);
#line 3117 "Document.c"
}

static void
paper_clip_document_create_copy_from_original (PaperClipDocument* self,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	PaperClipDocumentCreateCopyFromOriginalData* _data_;
	PaperClipDocument* _tmp0_;
#line 21 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Document.vala"
	_data_ = g_slice_new0 (PaperClipDocumentCreateCopyFromOriginalData);
#line 21 "../src/Document.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 21 "../src/Document.vala"
	g_task_set_task_data (_data_->_async_result, _data_, paper_clip_document_create_copy_from_original_data_free);
#line 21 "../src/Document.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../src/Document.vala"
	_data_->self = _tmp0_;
#line 21 "../src/Document.vala"
	paper_clip_document_create_copy_from_original_co (_data_);
#line 3141 "Document.c"
}

static GFile*
paper_clip_document_create_copy_from_original_finish (PaperClipDocument* self,
                                                      GAsyncResult* _res_,
                                                      GError** error)
{
	GFile* result;
	PaperClipDocumentCreateCopyFromOriginalData* _data_;
#line 21 "../src/Document.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 21 "../src/Document.vala"
	if (NULL == _data_) {
#line 21 "../src/Document.vala"
		return NULL;
#line 3157 "Document.c"
	}
#line 21 "../src/Document.vala"
	result = _data_->result;
#line 21 "../src/Document.vala"
	_data_->result = NULL;
#line 21 "../src/Document.vala"
	return result;
#line 3165 "Document.c"
}

static void
paper_clip_document_create_copy_from_original_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	PaperClipDocumentCreateCopyFromOriginalData* _data_;
#line 462 "../src/Document.vala"
	_data_ = _user_data_;
#line 462 "../src/Document.vala"
	_data_->_source_object_ = source_object;
#line 462 "../src/Document.vala"
	_data_->_res_ = _res_;
#line 462 "../src/Document.vala"
	paper_clip_document_create_copy_from_original_co (_data_);
#line 3182 "Document.c"
}

static gboolean
paper_clip_document_create_copy_from_original_co (PaperClipDocumentCreateCopyFromOriginalData* _data_)
{
#line 447 "../src/Document.vala"
	switch (_data_->_state_) {
#line 447 "../src/Document.vala"
		case 0:
#line 3192 "Document.c"
		goto _state_0;
#line 447 "../src/Document.vala"
		case 1:
#line 3196 "Document.c"
		goto _state_1;
		default:
#line 447 "../src/Document.vala"
		g_assert_not_reached ();
#line 3201 "Document.c"
	}
	_state_0:
#line 448 "../src/Document.vala"
	_data_->_tmp0_ = g_get_tmp_dir ();
#line 448 "../src/Document.vala"
	_data_->tmp_dir = _data_->_tmp0_;
#line 449 "../src/Document.vala"
	_data_->_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _data_->tmp_dir, "copies", NULL);
#line 449 "../src/Document.vala"
	_data_->destination_path = _data_->_tmp1_;
#line 453 "../src/Document.vala"
	_data_->res = g_mkdir_with_parents (_data_->destination_path, 0777);
#line 454 "../src/Document.vala"
	g_return_if_fail (_data_->res > -1);
#line 456 "../src/Document.vala"
	_data_->_tmp2_ = _data_->self->priv->_original_file;
#line 456 "../src/Document.vala"
	_data_->_tmp3_ = g_file_get_basename (_data_->_tmp2_);
#line 456 "../src/Document.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 456 "../src/Document.vala"
	_data_->_tmp5_ = g_strdup_printf ("%s", _data_->_tmp4_);
#line 456 "../src/Document.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 456 "../src/Document.vala"
	_data_->_tmp7_ = g_build_filename (_data_->destination_path, _data_->_tmp6_, NULL);
#line 456 "../src/Document.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 456 "../src/Document.vala"
	_g_free0 (_data_->_tmp6_);
#line 456 "../src/Document.vala"
	_g_free0 (_data_->_tmp4_);
#line 456 "../src/Document.vala"
	_data_->destination_file = _data_->_tmp8_;
#line 459 "../src/Document.vala"
	_data_->_tmp9_ = g_file_new_for_path (_data_->destination_file);
#line 459 "../src/Document.vala"
	_data_->copy_file = _data_->_tmp9_;
#line 460 "../src/Document.vala"
	_data_->flags = (G_FILE_COPY_NOFOLLOW_SYMLINKS | G_FILE_COPY_OVERWRITE) | G_FILE_COPY_ALL_METADATA;
#line 462 "../src/Document.vala"
	_data_->_tmp10_ = _data_->self->priv->_original_file;
#line 462 "../src/Document.vala"
	_data_->_state_ = 1;
#line 462 "../src/Document.vala"
	g_file_copy_async (_data_->_tmp10_, _data_->copy_file, _data_->flags, G_PRIORITY_DEFAULT, NULL, NULL, NULL, paper_clip_document_create_copy_from_original_ready, _data_);
#line 462 "../src/Document.vala"
	return FALSE;
#line 3250 "Document.c"
	_state_1:
#line 462 "../src/Document.vala"
	_data_->success = g_file_copy_finish (_data_->_tmp10_, _data_->_res_, &_data_->_inner_error0_);
#line 462 "../src/Document.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 462 "../src/Document.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 462 "../src/Document.vala"
		_g_object_unref0 (_data_->copy_file);
#line 462 "../src/Document.vala"
		_g_free0 (_data_->destination_file);
#line 462 "../src/Document.vala"
		_g_free0 (_data_->destination_path);
#line 462 "../src/Document.vala"
		g_object_unref (_data_->_async_result);
#line 462 "../src/Document.vala"
		return FALSE;
#line 3268 "Document.c"
	}
#line 463 "../src/Document.vala"
	if (!_data_->success) {
#line 464 "../src/Document.vala"
		g_critical ("Document.vala:464: Copy Unsuccessful");
#line 3274 "Document.c"
	}
#line 467 "../src/Document.vala"
	_data_->result = _data_->copy_file;
#line 467 "../src/Document.vala"
	_g_free0 (_data_->destination_file);
#line 467 "../src/Document.vala"
	_g_free0 (_data_->destination_path);
#line 467 "../src/Document.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 467 "../src/Document.vala"
	if (_data_->_state_ != 0) {
#line 467 "../src/Document.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 467 "../src/Document.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3290 "Document.c"
		}
	}
#line 467 "../src/Document.vala"
	g_object_unref (_data_->_async_result);
#line 467 "../src/Document.vala"
	return FALSE;
#line 3297 "Document.c"
}

static PopplerDocument*
paper_clip_document_get_document (PaperClipDocument* self)
{
	PopplerDocument* result;
	PopplerDocument* _tmp0_;
#line 29 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Document.vala"
	_tmp0_ = self->priv->_document;
#line 30 "../src/Document.vala"
	result = _tmp0_;
#line 30 "../src/Document.vala"
	return result;
#line 3313 "Document.c"
}

static void
paper_clip_document_set_document (PaperClipDocument* self,
                                  PopplerDocument* value)
{
	PopplerDocument* _tmp0_;
#line 32 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Document.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 33 "../src/Document.vala"
	_g_object_unref0 (self->priv->_document);
#line 33 "../src/Document.vala"
	self->priv->_document = _tmp0_;
#line 34 "../src/Document.vala"
	paper_clip_document_deserialize_keywords (self);
#line 3331 "Document.c"
}

GFile*
paper_clip_document_get_original_file (PaperClipDocument* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 38 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Document.vala"
	_tmp0_ = self->priv->_original_file;
#line 38 "../src/Document.vala"
	result = _tmp0_;
#line 38 "../src/Document.vala"
	return result;
#line 3347 "Document.c"
}

static void
paper_clip_document_set_original_file (PaperClipDocument* self,
                                       GFile* value)
{
	GFile* old_value;
#line 38 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Document.vala"
	old_value = paper_clip_document_get_original_file (self);
#line 38 "../src/Document.vala"
	if (old_value != value) {
#line 3361 "Document.c"
		GFile* _tmp0_;
#line 38 "../src/Document.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/Document.vala"
		_g_object_unref0 (self->priv->_original_file);
#line 38 "../src/Document.vala"
		self->priv->_original_file = _tmp0_;
#line 38 "../src/Document.vala"
		g_object_notify_by_pspec ((GObject *) self, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_ORIGINAL_FILE_PROPERTY]);
#line 3371 "Document.c"
	}
}

GFile*
paper_clip_document_get_cached_file (PaperClipDocument* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 39 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Document.vala"
	_tmp0_ = self->priv->_cached_file;
#line 39 "../src/Document.vala"
	result = _tmp0_;
#line 39 "../src/Document.vala"
	return result;
#line 3388 "Document.c"
}

static void
paper_clip_document_set_cached_file (PaperClipDocument* self,
                                     GFile* value)
{
	GFile* old_value;
#line 39 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Document.vala"
	old_value = paper_clip_document_get_cached_file (self);
#line 39 "../src/Document.vala"
	if (old_value != value) {
#line 3402 "Document.c"
		GFile* _tmp0_;
#line 39 "../src/Document.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../src/Document.vala"
		_g_object_unref0 (self->priv->_cached_file);
#line 39 "../src/Document.vala"
		self->priv->_cached_file = _tmp0_;
#line 39 "../src/Document.vala"
		g_object_notify_by_pspec ((GObject *) self, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_CACHED_FILE_PROPERTY]);
#line 3412 "Document.c"
	}
}

gboolean
paper_clip_document_get_has_xmp (PaperClipDocument* self)
{
	gboolean result;
#line 42 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/Document.vala"
	result = self->priv->_has_xmp;
#line 42 "../src/Document.vala"
	return result;
#line 3426 "Document.c"
}

static void
paper_clip_document_set_has_xmp (PaperClipDocument* self,
                                 gboolean value)
{
#line 42 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Document.vala"
	self->priv->_has_xmp = value;
#line 3437 "Document.c"
}

gchar*
paper_clip_document_get_author (PaperClipDocument* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	PopplerDocument* _tmp1_;
	PopplerDocument* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp6_;
#line 45 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/Document.vala"
	_tmp1_ = paper_clip_document_get_document (self);
#line 46 "../src/Document.vala"
	_tmp2_ = _tmp1_;
#line 46 "../src/Document.vala"
	_tmp3_ = poppler_document_get_author (_tmp2_);
#line 46 "../src/Document.vala"
	_tmp4_ = _tmp3_;
#line 46 "../src/Document.vala"
	_tmp0_ = _tmp4_;
#line 46 "../src/Document.vala"
	if (_tmp0_ == NULL) {
#line 3464 "Document.c"
		gchar* _tmp5_;
#line 46 "../src/Document.vala"
		_tmp5_ = g_strdup ("");
#line 46 "../src/Document.vala"
		_g_free0 (_tmp0_);
#line 46 "../src/Document.vala"
		_tmp0_ = _tmp5_;
#line 3472 "Document.c"
	}
#line 46 "../src/Document.vala"
	_tmp6_ = _tmp0_;
#line 46 "../src/Document.vala"
	_tmp0_ = NULL;
#line 46 "../src/Document.vala"
	result = _tmp6_;
#line 46 "../src/Document.vala"
	_g_free0 (_tmp0_);
#line 46 "../src/Document.vala"
	return result;
#line 3484 "Document.c"
}

void
paper_clip_document_set_author (PaperClipDocument* self,
                                const gchar* value)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
#line 48 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 49 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 49 "../src/Document.vala"
	poppler_document_set_author (_tmp1_, value);
#line 48 "../src/Document.vala"
	g_object_notify_by_pspec ((GObject *) self, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_AUTHOR_PROPERTY]);
#line 3503 "Document.c"
}

gchar*
paper_clip_document_get_creator (PaperClipDocument* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	PopplerDocument* _tmp1_;
	PopplerDocument* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp6_;
#line 54 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/Document.vala"
	_tmp1_ = paper_clip_document_get_document (self);
#line 55 "../src/Document.vala"
	_tmp2_ = _tmp1_;
#line 55 "../src/Document.vala"
	_tmp3_ = poppler_document_get_creator (_tmp2_);
#line 55 "../src/Document.vala"
	_tmp4_ = _tmp3_;
#line 55 "../src/Document.vala"
	_tmp0_ = _tmp4_;
#line 55 "../src/Document.vala"
	if (_tmp0_ == NULL) {
#line 3530 "Document.c"
		gchar* _tmp5_;
#line 55 "../src/Document.vala"
		_tmp5_ = g_strdup ("");
#line 55 "../src/Document.vala"
		_g_free0 (_tmp0_);
#line 55 "../src/Document.vala"
		_tmp0_ = _tmp5_;
#line 3538 "Document.c"
	}
#line 55 "../src/Document.vala"
	_tmp6_ = _tmp0_;
#line 55 "../src/Document.vala"
	_tmp0_ = NULL;
#line 55 "../src/Document.vala"
	result = _tmp6_;
#line 55 "../src/Document.vala"
	_g_free0 (_tmp0_);
#line 55 "../src/Document.vala"
	return result;
#line 3550 "Document.c"
}

void
paper_clip_document_set_creator (PaperClipDocument* self,
                                 const gchar* value)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
#line 57 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 58 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Document.vala"
	poppler_document_set_creator (_tmp1_, value);
#line 57 "../src/Document.vala"
	g_object_notify_by_pspec ((GObject *) self, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_CREATOR_PROPERTY]);
#line 3569 "Document.c"
}

gchar*
paper_clip_document_get_subject (PaperClipDocument* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	PopplerDocument* _tmp1_;
	PopplerDocument* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp6_;
#line 63 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../src/Document.vala"
	_tmp1_ = paper_clip_document_get_document (self);
#line 64 "../src/Document.vala"
	_tmp2_ = _tmp1_;
#line 64 "../src/Document.vala"
	_tmp3_ = poppler_document_get_subject (_tmp2_);
#line 64 "../src/Document.vala"
	_tmp4_ = _tmp3_;
#line 64 "../src/Document.vala"
	_tmp0_ = _tmp4_;
#line 64 "../src/Document.vala"
	if (_tmp0_ == NULL) {
#line 3596 "Document.c"
		gchar* _tmp5_;
#line 64 "../src/Document.vala"
		_tmp5_ = g_strdup ("");
#line 64 "../src/Document.vala"
		_g_free0 (_tmp0_);
#line 64 "../src/Document.vala"
		_tmp0_ = _tmp5_;
#line 3604 "Document.c"
	}
#line 64 "../src/Document.vala"
	_tmp6_ = _tmp0_;
#line 64 "../src/Document.vala"
	_tmp0_ = NULL;
#line 64 "../src/Document.vala"
	result = _tmp6_;
#line 64 "../src/Document.vala"
	_g_free0 (_tmp0_);
#line 64 "../src/Document.vala"
	return result;
#line 3616 "Document.c"
}

void
paper_clip_document_set_subject (PaperClipDocument* self,
                                 const gchar* value)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
#line 66 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 67 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 67 "../src/Document.vala"
	poppler_document_set_subject (_tmp1_, value);
#line 66 "../src/Document.vala"
	g_object_notify_by_pspec ((GObject *) self, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_SUBJECT_PROPERTY]);
#line 3635 "Document.c"
}

gchar*
paper_clip_document_get_title (PaperClipDocument* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	PopplerDocument* _tmp1_;
	PopplerDocument* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp6_;
#line 72 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../src/Document.vala"
	_tmp1_ = paper_clip_document_get_document (self);
#line 73 "../src/Document.vala"
	_tmp2_ = _tmp1_;
#line 73 "../src/Document.vala"
	_tmp3_ = poppler_document_get_title (_tmp2_);
#line 73 "../src/Document.vala"
	_tmp4_ = _tmp3_;
#line 73 "../src/Document.vala"
	_tmp0_ = _tmp4_;
#line 73 "../src/Document.vala"
	if (_tmp0_ == NULL) {
#line 3662 "Document.c"
		gchar* _tmp5_;
#line 73 "../src/Document.vala"
		_tmp5_ = g_strdup ("");
#line 73 "../src/Document.vala"
		_g_free0 (_tmp0_);
#line 73 "../src/Document.vala"
		_tmp0_ = _tmp5_;
#line 3670 "Document.c"
	}
#line 73 "../src/Document.vala"
	_tmp6_ = _tmp0_;
#line 73 "../src/Document.vala"
	_tmp0_ = NULL;
#line 73 "../src/Document.vala"
	result = _tmp6_;
#line 73 "../src/Document.vala"
	_g_free0 (_tmp0_);
#line 73 "../src/Document.vala"
	return result;
#line 3682 "Document.c"
}

void
paper_clip_document_set_title (PaperClipDocument* self,
                               const gchar* value)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
#line 75 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 76 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 76 "../src/Document.vala"
	poppler_document_set_title (_tmp1_, value);
#line 75 "../src/Document.vala"
	g_object_notify_by_pspec ((GObject *) self, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_TITLE_PROPERTY]);
#line 3701 "Document.c"
}

gchar*
paper_clip_document_get_producer (PaperClipDocument* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	PopplerDocument* _tmp1_;
	PopplerDocument* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp6_;
#line 81 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "../src/Document.vala"
	_tmp1_ = paper_clip_document_get_document (self);
#line 82 "../src/Document.vala"
	_tmp2_ = _tmp1_;
#line 82 "../src/Document.vala"
	_tmp3_ = poppler_document_get_producer (_tmp2_);
#line 82 "../src/Document.vala"
	_tmp4_ = _tmp3_;
#line 82 "../src/Document.vala"
	_tmp0_ = _tmp4_;
#line 82 "../src/Document.vala"
	if (_tmp0_ == NULL) {
#line 3728 "Document.c"
		gchar* _tmp5_;
#line 82 "../src/Document.vala"
		_tmp5_ = g_strdup ("");
#line 82 "../src/Document.vala"
		_g_free0 (_tmp0_);
#line 82 "../src/Document.vala"
		_tmp0_ = _tmp5_;
#line 3736 "Document.c"
	}
#line 82 "../src/Document.vala"
	_tmp6_ = _tmp0_;
#line 82 "../src/Document.vala"
	_tmp0_ = NULL;
#line 82 "../src/Document.vala"
	result = _tmp6_;
#line 82 "../src/Document.vala"
	_g_free0 (_tmp0_);
#line 82 "../src/Document.vala"
	return result;
#line 3748 "Document.c"
}

void
paper_clip_document_set_producer (PaperClipDocument* self,
                                  const gchar* value)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
#line 84 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 85 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 85 "../src/Document.vala"
	poppler_document_set_producer (_tmp1_, value);
#line 84 "../src/Document.vala"
	g_object_notify_by_pspec ((GObject *) self, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_PRODUCER_PROPERTY]);
#line 3767 "Document.c"
}

GDateTime*
paper_clip_document_get_creation_date (PaperClipDocument* self)
{
	GDateTime* result;
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
#line 90 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 91 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 91 "../src/Document.vala"
	g_object_get (_tmp1_, "creation-datetime", &_tmp2_, NULL);
#line 91 "../src/Document.vala"
	_tmp3_ = _tmp2_;
#line 91 "../src/Document.vala"
	result = _tmp3_;
#line 91 "../src/Document.vala"
	return result;
#line 3792 "Document.c"
}

void
paper_clip_document_set_creation_date (PaperClipDocument* self,
                                       GDateTime* value)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
#line 93 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 94 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 94 "../src/Document.vala"
	g_object_set (_tmp1_, "creation-datetime", value, NULL);
#line 93 "../src/Document.vala"
	g_object_notify_by_pspec ((GObject *) self, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_CREATION_DATE_PROPERTY]);
#line 3811 "Document.c"
}

GDateTime*
paper_clip_document_get_modification_date (PaperClipDocument* self)
{
	GDateTime* result;
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
#line 99 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 100 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 100 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 100 "../src/Document.vala"
	g_object_get (_tmp1_, "mod-datetime", &_tmp2_, NULL);
#line 100 "../src/Document.vala"
	_tmp3_ = _tmp2_;
#line 100 "../src/Document.vala"
	result = _tmp3_;
#line 100 "../src/Document.vala"
	return result;
#line 3836 "Document.c"
}

void
paper_clip_document_set_modification_date (PaperClipDocument* self,
                                           GDateTime* value)
{
	PopplerDocument* _tmp0_;
	PopplerDocument* _tmp1_;
#line 102 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/Document.vala"
	_tmp0_ = paper_clip_document_get_document (self);
#line 103 "../src/Document.vala"
	_tmp1_ = _tmp0_;
#line 103 "../src/Document.vala"
	g_object_set (_tmp1_, "mod-datetime", value, NULL);
#line 102 "../src/Document.vala"
	g_object_notify_by_pspec ((GObject *) self, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_MODIFICATION_DATE_PROPERTY]);
#line 3855 "Document.c"
}

GListModel*
paper_clip_document_get_keywords (PaperClipDocument* self)
{
	GListModel* result;
	GListStore* _tmp0_;
#line 109 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "../src/Document.vala"
	_tmp0_ = self->priv->keyword_list;
#line 110 "../src/Document.vala"
	result = (GListModel*) _tmp0_;
#line 110 "../src/Document.vala"
	return result;
#line 3871 "Document.c"
}

gchar*
paper_clip_document_get_format (PaperClipDocument* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	PopplerDocument* _tmp1_;
	PopplerDocument* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp6_;
#line 116 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 117 "../src/Document.vala"
	_tmp1_ = paper_clip_document_get_document (self);
#line 117 "../src/Document.vala"
	_tmp2_ = _tmp1_;
#line 117 "../src/Document.vala"
	g_object_get (_tmp2_, "format", &_tmp3_, NULL);
#line 117 "../src/Document.vala"
	_tmp4_ = _tmp3_;
#line 117 "../src/Document.vala"
	_tmp0_ = _tmp4_;
#line 117 "../src/Document.vala"
	if (_tmp0_ == NULL) {
#line 3898 "Document.c"
		gchar* _tmp5_;
#line 117 "../src/Document.vala"
		_tmp5_ = g_strdup (_ ("Unknown"));
#line 117 "../src/Document.vala"
		_g_free0 (_tmp0_);
#line 117 "../src/Document.vala"
		_tmp0_ = _tmp5_;
#line 3906 "Document.c"
	}
#line 117 "../src/Document.vala"
	_tmp6_ = _tmp0_;
#line 117 "../src/Document.vala"
	_tmp0_ = NULL;
#line 117 "../src/Document.vala"
	result = _tmp6_;
#line 117 "../src/Document.vala"
	_g_free0 (_tmp0_);
#line 117 "../src/Document.vala"
	return result;
#line 3918 "Document.c"
}

gchar*
paper_clip_document_get_layout (PaperClipDocument* self)
{
	gchar* result;
	gchar* _tmp0_;
#line 123 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 124 "../src/Document.vala"
	_tmp0_ = paper_clip_document_layout_to_string (self);
#line 124 "../src/Document.vala"
	result = _tmp0_;
#line 124 "../src/Document.vala"
	return result;
#line 3934 "Document.c"
}

gchar*
paper_clip_document_get_print_duplex (PaperClipDocument* self)
{
	gchar* result;
	gchar* _tmp0_;
#line 130 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 131 "../src/Document.vala"
	_tmp0_ = paper_clip_document_print_duplex_to_string (self);
#line 131 "../src/Document.vala"
	result = _tmp0_;
#line 131 "../src/Document.vala"
	return result;
#line 3950 "Document.c"
}

gchar*
paper_clip_document_get_subtype (PaperClipDocument* self)
{
	gchar* result;
	gchar* _tmp0_;
#line 137 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "../src/Document.vala"
	_tmp0_ = paper_clip_document_subtype_to_string (self);
#line 138 "../src/Document.vala"
	result = _tmp0_;
#line 138 "../src/Document.vala"
	return result;
#line 3966 "Document.c"
}

gchar**
paper_clip_document_get_viewer_preferences (PaperClipDocument* self,
                                            gint* result_length1)
{
	gchar** result;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 144 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../src/Document.vala"
	_tmp1_ = paper_clip_document_viewer_preferences_to_string_array (self, &_tmp0_);
#line 145 "../src/Document.vala"
	_tmp2_ = _tmp1_;
#line 145 "../src/Document.vala"
	_tmp2__length1 = _tmp0_;
#line 145 "../src/Document.vala"
	if (result_length1) {
#line 145 "../src/Document.vala"
		*result_length1 = _tmp2__length1;
#line 3990 "Document.c"
	}
#line 145 "../src/Document.vala"
	result = _tmp2_;
#line 145 "../src/Document.vala"
	return result;
#line 3996 "Document.c"
}

gchar**
paper_clip_document_get_permissions (PaperClipDocument* self,
                                     gint* result_length1)
{
	gchar** result;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 151 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 152 "../src/Document.vala"
	_tmp1_ = paper_clip_document_permissions_to_string_array (self, &_tmp0_);
#line 152 "../src/Document.vala"
	_tmp2_ = _tmp1_;
#line 152 "../src/Document.vala"
	_tmp2__length1 = _tmp0_;
#line 152 "../src/Document.vala"
	if (result_length1) {
#line 152 "../src/Document.vala"
		*result_length1 = _tmp2__length1;
#line 4020 "Document.c"
	}
#line 152 "../src/Document.vala"
	result = _tmp2_;
#line 152 "../src/Document.vala"
	return result;
#line 4026 "Document.c"
}

static void
paper_clip_document_class_init (PaperClipDocumentClass * klass,
                                gpointer klass_data)
{
#line 21 "../src/Document.vala"
	paper_clip_document_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Document.vala"
	g_type_class_adjust_private_offset (klass, &PaperClipDocument_private_offset);
#line 21 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_paper_clip_document_get_property;
#line 21 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_paper_clip_document_set_property;
#line 21 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->finalize = paper_clip_document_finalize;
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_ORIGINAL_FILE_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_ORIGINAL_FILE_PROPERTY] = g_param_spec_object ("original-file", "original-file", "original-file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_CACHED_FILE_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_CACHED_FILE_PROPERTY] = g_param_spec_object ("cached-file", "cached-file", "cached-file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_HAS_XMP_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_HAS_XMP_PROPERTY] = g_param_spec_boolean ("has-xmp", "has-xmp", "has-xmp", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_AUTHOR_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_AUTHOR_PROPERTY] = g_param_spec_string ("author", "author", "author", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_CREATOR_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_CREATOR_PROPERTY] = g_param_spec_string ("creator", "creator", "creator", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_SUBJECT_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_SUBJECT_PROPERTY] = g_param_spec_string ("subject", "subject", "subject", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_TITLE_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_PRODUCER_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_PRODUCER_PROPERTY] = g_param_spec_string ("producer", "producer", "producer", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_CREATION_DATE_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_CREATION_DATE_PROPERTY] = g_param_spec_boxed ("creation-date", "creation-date", "creation-date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_MODIFICATION_DATE_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_MODIFICATION_DATE_PROPERTY] = g_param_spec_boxed ("modification-date", "modification-date", "modification-date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_KEYWORDS_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_KEYWORDS_PROPERTY] = g_param_spec_object ("keywords", "keywords", "keywords", g_list_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_FORMAT_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_FORMAT_PROPERTY] = g_param_spec_string ("format", "format", "format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_LAYOUT_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_LAYOUT_PROPERTY] = g_param_spec_string ("layout", "layout", "layout", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_PRINT_DUPLEX_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_PRINT_DUPLEX_PROPERTY] = g_param_spec_string ("print-duplex", "print-duplex", "print-duplex", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_SUBTYPE_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_SUBTYPE_PROPERTY] = g_param_spec_string ("subtype", "subtype", "subtype", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_VIEWER_PREFERENCES_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_VIEWER_PREFERENCES_PROPERTY] = g_param_spec_boxed ("viewer-preferences", "viewer-preferences", "viewer-preferences", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_DOCUMENT_PERMISSIONS_PROPERTY, paper_clip_document_properties[PAPER_CLIP_DOCUMENT_PERMISSIONS_PROPERTY] = g_param_spec_boxed ("permissions", "permissions", "permissions", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/Document.vala"
	paper_clip_document_signals[PAPER_CLIP_DOCUMENT_KEYWORD_CHANGED_SIGNAL] = g_signal_new ("keyword-changed", PAPER_CLIP_TYPE_DOCUMENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4079 "Document.c"
}

static void
paper_clip_document_instance_init (PaperClipDocument * self,
                                   gpointer klass)
{
	GListStore* _tmp0_;
#line 21 "../src/Document.vala"
	self->priv = paper_clip_document_get_instance_private (self);
#line 22 "../src/Document.vala"
	_tmp0_ = g_list_store_new (PAPER_CLIP_TYPE_STRING_OBJECT);
#line 22 "../src/Document.vala"
	self->priv->keyword_list = _tmp0_;
#line 42 "../src/Document.vala"
	self->priv->_has_xmp = FALSE;
#line 21 "../src/Document.vala"
	g_rec_mutex_init (&self->priv->__lock_document);
#line 4097 "Document.c"
}

static void
paper_clip_document_finalize (GObject * obj)
{
	PaperClipDocument * self;
#line 21 "../src/Document.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PAPER_CLIP_TYPE_DOCUMENT, PaperClipDocument);
#line 22 "../src/Document.vala"
	_g_object_unref0 (self->priv->keyword_list);
#line 27 "../src/Document.vala"
	_g_object_unref0 (self->priv->_document);
#line 38 "../src/Document.vala"
	_g_object_unref0 (self->priv->_original_file);
#line 39 "../src/Document.vala"
	_g_object_unref0 (self->priv->_cached_file);
#line 21 "../src/Document.vala"
	g_rec_mutex_clear (&self->priv->__lock_document);
#line 21 "../src/Document.vala"
	G_OBJECT_CLASS (paper_clip_document_parent_class)->finalize (obj);
#line 4118 "Document.c"
}

static GType
paper_clip_document_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PaperClipDocumentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) paper_clip_document_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PaperClipDocument), 0, (GInstanceInitFunc) paper_clip_document_instance_init, NULL };
	GType paper_clip_document_type_id;
	paper_clip_document_type_id = g_type_register_static (G_TYPE_OBJECT, "PaperClipDocument", &g_define_type_info, 0);
	PaperClipDocument_private_offset = g_type_add_instance_private (paper_clip_document_type_id, sizeof (PaperClipDocumentPrivate));
	return paper_clip_document_type_id;
}

GType
paper_clip_document_get_type (void)
{
	static volatile gsize paper_clip_document_type_id__once = 0;
	if (g_once_init_enter (&paper_clip_document_type_id__once)) {
		GType paper_clip_document_type_id;
		paper_clip_document_type_id = paper_clip_document_get_type_once ();
		g_once_init_leave (&paper_clip_document_type_id__once, paper_clip_document_type_id);
	}
	return paper_clip_document_type_id__once;
}

static void
_vala_paper_clip_document_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	PaperClipDocument * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PAPER_CLIP_TYPE_DOCUMENT, PaperClipDocument);
#line 21 "../src/Document.vala"
	switch (property_id) {
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_ORIGINAL_FILE_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_set_object (value, paper_clip_document_get_original_file (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_CACHED_FILE_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_set_object (value, paper_clip_document_get_cached_file (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_HAS_XMP_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_set_boolean (value, paper_clip_document_get_has_xmp (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_AUTHOR_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_take_string (value, paper_clip_document_get_author (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_CREATOR_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_take_string (value, paper_clip_document_get_creator (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_SUBJECT_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_take_string (value, paper_clip_document_get_subject (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_TITLE_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_take_string (value, paper_clip_document_get_title (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_PRODUCER_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_take_string (value, paper_clip_document_get_producer (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_CREATION_DATE_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_take_boxed (value, paper_clip_document_get_creation_date (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_MODIFICATION_DATE_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_take_boxed (value, paper_clip_document_get_modification_date (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_KEYWORDS_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_set_object (value, paper_clip_document_get_keywords (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_FORMAT_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_take_string (value, paper_clip_document_get_format (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_LAYOUT_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_take_string (value, paper_clip_document_get_layout (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_PRINT_DUPLEX_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_take_string (value, paper_clip_document_get_print_duplex (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_SUBTYPE_PROPERTY:
#line 21 "../src/Document.vala"
		g_value_take_string (value, paper_clip_document_get_subtype (self));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_VIEWER_PREFERENCES_PROPERTY:
#line 4245 "Document.c"
		{
			int length;
#line 21 "../src/Document.vala"
			g_value_take_boxed (value, paper_clip_document_get_viewer_preferences (self, &length));
#line 4250 "Document.c"
		}
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_PERMISSIONS_PROPERTY:
#line 4256 "Document.c"
		{
			int length;
#line 21 "../src/Document.vala"
			g_value_take_boxed (value, paper_clip_document_get_permissions (self, &length));
#line 4261 "Document.c"
		}
#line 21 "../src/Document.vala"
		break;
#line 4265 "Document.c"
		default:
#line 21 "../src/Document.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Document.vala"
		break;
#line 4271 "Document.c"
	}
}

static void
_vala_paper_clip_document_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	PaperClipDocument * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PAPER_CLIP_TYPE_DOCUMENT, PaperClipDocument);
#line 21 "../src/Document.vala"
	switch (property_id) {
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_ORIGINAL_FILE_PROPERTY:
#line 21 "../src/Document.vala"
		paper_clip_document_set_original_file (self, g_value_get_object (value));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_CACHED_FILE_PROPERTY:
#line 21 "../src/Document.vala"
		paper_clip_document_set_cached_file (self, g_value_get_object (value));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_HAS_XMP_PROPERTY:
#line 21 "../src/Document.vala"
		paper_clip_document_set_has_xmp (self, g_value_get_boolean (value));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_AUTHOR_PROPERTY:
#line 21 "../src/Document.vala"
		paper_clip_document_set_author (self, g_value_get_string (value));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_CREATOR_PROPERTY:
#line 21 "../src/Document.vala"
		paper_clip_document_set_creator (self, g_value_get_string (value));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_SUBJECT_PROPERTY:
#line 21 "../src/Document.vala"
		paper_clip_document_set_subject (self, g_value_get_string (value));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_TITLE_PROPERTY:
#line 21 "../src/Document.vala"
		paper_clip_document_set_title (self, g_value_get_string (value));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_PRODUCER_PROPERTY:
#line 21 "../src/Document.vala"
		paper_clip_document_set_producer (self, g_value_get_string (value));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_CREATION_DATE_PROPERTY:
#line 21 "../src/Document.vala"
		paper_clip_document_set_creation_date (self, g_value_get_boxed (value));
#line 21 "../src/Document.vala"
		break;
#line 21 "../src/Document.vala"
		case PAPER_CLIP_DOCUMENT_MODIFICATION_DATE_PROPERTY:
#line 21 "../src/Document.vala"
		paper_clip_document_set_modification_date (self, g_value_get_boxed (value));
#line 21 "../src/Document.vala"
		break;
#line 4345 "Document.c"
		default:
#line 21 "../src/Document.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Document.vala"
		break;
#line 4351 "Document.c"
	}
}

static inline gpointer
paper_clip_string_object_get_instance_private (PaperClipStringObject* self)
{
	return G_STRUCT_MEMBER_P (self, PaperClipStringObject_private_offset);
}

PaperClipStringObject*
paper_clip_string_object_construct (GType object_type,
                                    const gchar* str)
{
	PaperClipStringObject * self = NULL;
#line 474 "../src/Document.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 475 "../src/Document.vala"
	self = (PaperClipStringObject*) g_object_new (object_type, "str", str, NULL);
#line 474 "../src/Document.vala"
	return self;
#line 4372 "Document.c"
}

PaperClipStringObject*
paper_clip_string_object_new (const gchar* str)
{
#line 474 "../src/Document.vala"
	return paper_clip_string_object_construct (PAPER_CLIP_TYPE_STRING_OBJECT, str);
#line 4380 "Document.c"
}

const gchar*
paper_clip_string_object_get_str (PaperClipStringObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 472 "../src/Document.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 472 "../src/Document.vala"
	_tmp0_ = self->priv->_str;
#line 472 "../src/Document.vala"
	result = _tmp0_;
#line 472 "../src/Document.vala"
	return result;
#line 4396 "Document.c"
}

void
paper_clip_string_object_set_str (PaperClipStringObject* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 472 "../src/Document.vala"
	g_return_if_fail (self != NULL);
#line 472 "../src/Document.vala"
	old_value = paper_clip_string_object_get_str (self);
#line 472 "../src/Document.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4410 "Document.c"
		gchar* _tmp0_;
#line 472 "../src/Document.vala"
		_tmp0_ = g_strdup (value);
#line 472 "../src/Document.vala"
		_g_free0 (self->priv->_str);
#line 472 "../src/Document.vala"
		self->priv->_str = _tmp0_;
#line 472 "../src/Document.vala"
		g_object_notify_by_pspec ((GObject *) self, paper_clip_string_object_properties[PAPER_CLIP_STRING_OBJECT_STR_PROPERTY]);
#line 4420 "Document.c"
	}
}

static void
paper_clip_string_object_class_init (PaperClipStringObjectClass * klass,
                                     gpointer klass_data)
{
#line 471 "../src/Document.vala"
	paper_clip_string_object_parent_class = g_type_class_peek_parent (klass);
#line 471 "../src/Document.vala"
	g_type_class_adjust_private_offset (klass, &PaperClipStringObject_private_offset);
#line 471 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_paper_clip_string_object_get_property;
#line 471 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_paper_clip_string_object_set_property;
#line 471 "../src/Document.vala"
	G_OBJECT_CLASS (klass)->finalize = paper_clip_string_object_finalize;
#line 471 "../src/Document.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAPER_CLIP_STRING_OBJECT_STR_PROPERTY, paper_clip_string_object_properties[PAPER_CLIP_STRING_OBJECT_STR_PROPERTY] = g_param_spec_string ("str", "str", "str", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4440 "Document.c"
}

static void
paper_clip_string_object_instance_init (PaperClipStringObject * self,
                                        gpointer klass)
{
	gchar* _tmp0_;
#line 471 "../src/Document.vala"
	self->priv = paper_clip_string_object_get_instance_private (self);
#line 472 "../src/Document.vala"
	_tmp0_ = g_strdup ("");
#line 472 "../src/Document.vala"
	self->priv->_str = _tmp0_;
#line 4454 "Document.c"
}

static void
paper_clip_string_object_finalize (GObject * obj)
{
	PaperClipStringObject * self;
#line 471 "../src/Document.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PAPER_CLIP_TYPE_STRING_OBJECT, PaperClipStringObject);
#line 472 "../src/Document.vala"
	_g_free0 (self->priv->_str);
#line 471 "../src/Document.vala"
	G_OBJECT_CLASS (paper_clip_string_object_parent_class)->finalize (obj);
#line 4467 "Document.c"
}

static GType
paper_clip_string_object_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PaperClipStringObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) paper_clip_string_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PaperClipStringObject), 0, (GInstanceInitFunc) paper_clip_string_object_instance_init, NULL };
	GType paper_clip_string_object_type_id;
	paper_clip_string_object_type_id = g_type_register_static (G_TYPE_OBJECT, "PaperClipStringObject", &g_define_type_info, 0);
	PaperClipStringObject_private_offset = g_type_add_instance_private (paper_clip_string_object_type_id, sizeof (PaperClipStringObjectPrivate));
	return paper_clip_string_object_type_id;
}

GType
paper_clip_string_object_get_type (void)
{
	static volatile gsize paper_clip_string_object_type_id__once = 0;
	if (g_once_init_enter (&paper_clip_string_object_type_id__once)) {
		GType paper_clip_string_object_type_id;
		paper_clip_string_object_type_id = paper_clip_string_object_get_type_once ();
		g_once_init_leave (&paper_clip_string_object_type_id__once, paper_clip_string_object_type_id);
	}
	return paper_clip_string_object_type_id__once;
}

static void
_vala_paper_clip_string_object_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	PaperClipStringObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PAPER_CLIP_TYPE_STRING_OBJECT, PaperClipStringObject);
#line 471 "../src/Document.vala"
	switch (property_id) {
#line 471 "../src/Document.vala"
		case PAPER_CLIP_STRING_OBJECT_STR_PROPERTY:
#line 471 "../src/Document.vala"
		g_value_set_string (value, paper_clip_string_object_get_str (self));
#line 471 "../src/Document.vala"
		break;
#line 4508 "Document.c"
		default:
#line 471 "../src/Document.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 471 "../src/Document.vala"
		break;
#line 4514 "Document.c"
	}
}

static void
_vala_paper_clip_string_object_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	PaperClipStringObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PAPER_CLIP_TYPE_STRING_OBJECT, PaperClipStringObject);
#line 471 "../src/Document.vala"
	switch (property_id) {
#line 471 "../src/Document.vala"
		case PAPER_CLIP_STRING_OBJECT_STR_PROPERTY:
#line 471 "../src/Document.vala"
		paper_clip_string_object_set_str (self, g_value_get_string (value));
#line 471 "../src/Document.vala"
		break;
#line 4534 "Document.c"
		default:
#line 471 "../src/Document.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 471 "../src/Document.vala"
		break;
#line 4540 "Document.c"
	}
}

GQuark
paper_clip_xmp_error_quark (void)
{
	return g_quark_from_static_string ("paper-clip-xmp-error-quark");
}

static GType
paper_clip_xmp_error_get_type_once (void)
{
	static const GEnumValue values[] = {{PAPER_CLIP_XMP_ERROR_NO_XMP, "PAPER_CLIP_XMP_ERROR_NO_XMP", "no-xmp"}, {PAPER_CLIP_XMP_ERROR_FAILED_TO_OPEN, "PAPER_CLIP_XMP_ERROR_FAILED_TO_OPEN", "failed-to-open"}, {0, NULL, NULL}};
	GType paper_clip_xmp_error_type_id;
	paper_clip_xmp_error_type_id = g_enum_register_static ("PaperClipXmpError", values);
	return paper_clip_xmp_error_type_id;
}

GType
paper_clip_xmp_error_get_type (void)
{
	static volatile gsize paper_clip_xmp_error_type_id__once = 0;
	if (g_once_init_enter (&paper_clip_xmp_error_type_id__once)) {
		GType paper_clip_xmp_error_type_id;
		paper_clip_xmp_error_type_id = paper_clip_xmp_error_get_type_once ();
		g_once_init_leave (&paper_clip_xmp_error_type_id__once, paper_clip_xmp_error_type_id);
	}
	return paper_clip_xmp_error_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

